'From Squeak3.4 of 1 March 2003 [latest update: #5170] on 11 March 2003 at 12:39:26 pm'!
Model subclass: #Celeste
	instanceVariableNames: 'mailDB currentCategory currentMessages currentMsgID lastCategory subjectFilter participantFilter customFilterBlock messageTextView userPassword status tocLists '
	classVariableNames: 'CCList CustomFilters CustomFiltersCompiled DeleteInboxAfterFetching FormatWhenFetching MessageCountLimit PopServer PopUserName SuppressWorthlessHeaderFields TimeZone '
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!Celeste commentStamp: '<historical>' prior: 0!
I am the core of a mail reading and organizing program. The name "Celeste" is a reference to an earlier mail reader named "Babar", which was written at Xerox PARC by Steve Putz and John Maloney.

This object provides a user interface and some higher-level functionality for the application. The foundation of of the mail reader is really the mail database, implemented by the class MailDB.

Implementation note: the 'mailDB' instance variable can be nil.  This way, it is possible to have a Celeste window with no DB currently loaded.  All user-accessible functions that access mailDB should be careful to quietly do nothing if mailDB is nil.!
]style[(382 6 254)f1,f1LMailDB Comment;,f1!

MailComposition subclass: #CelesteComposition
	instanceVariableNames: 'celeste '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!CelesteComposition commentStamp: '<historical>' prior: 0!
a message being composed.  When finished, it will be submitted via a Celeste.!

TestCase subclass: #CelesteTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!
Object subclass: #IndexFileEntry
	instanceVariableNames: 'messageFile msgID location textLength time from to cc subject tocLineCache '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!IndexFileEntry commentStamp: '<historical>' prior: 0!
An IndexFileEntry contains enough information to present a table-of-contents entry for the message and to support simple filtering based on a subset of the mail header information. The IndexFile maps unique message ID's to IndexFileEntries.

!

Model subclass: #MailDB
	instanceVariableNames: 'rootFilename messageFile indexFile categoriesFile canRenumberMsgIDs lastIssuedMsgID '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!MailDB commentStamp: '<historical>' prior: 0!
I am the in-memory representation of a Celeste mail database. A mail database named "current" consists of three files:

	current.messages	-- an append-only file containing the full content of all messages
	current.index		-- an index of all messages in the messages file that maps unique
						   message ID's to index entries containing some header information
						   and the offset of the full message in the .messages file
	current.categories	-- maps category names to collections of message ID's

Each open mail database has a MailDB object that manages these three files. Operations such as fetching a message given its unique ID and finding out which messages are in which category are supported by the MailDB object. It also supports incorporating new messages (reading mail), message editing and deletions, and message file compaction and recovery.

canRenumberMsgIDs is used only during compacting the message file.  It controls whether renumbering can happen for messages which have duplicate (and therefore not unique) messageIDs.  It is an instance variable so that it can control behaviour in subsequent compactions.  Please do not use it for other behaviour.

lastIssuedMsgID contains the most recently issued message ID.  It is mostly private to nextUnusedID, though it is also cleared in the compact routine.  Otherwise, please do not read or write it.!

Object subclass: #MailDBFile
	instanceVariableNames: 'filename '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!MailDBFile commentStamp: '<historical>' prior: 0!
I am an abstract class that collects some of the operations common to all mail database files.
!

MailDBFile variableSubclass: #CategoriesFile
	instanceVariableNames: 'categories '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!CategoriesFile commentStamp: '<historical>' prior: 0!
I represent the organization of the mail database into set of message lists called "categories".  Each category contains a collection of message ID's.  The same message may be cross-filed quite cheaply by storing it's ID in multiple categories.

The categories information is kept in a binary file on the disk.  It is read into memory in its entirety when the mail database is opened.  To make changes persist, the categories information must be saved out to disk.  This should be done after fetching new mail and when the mail database is closed.  It could also be done periodically by some sort of background process.

Note that the categories file, unlike the index file, cannot be re-created from the messages file.
!

MailDBFile subclass: #IndexFile
	instanceVariableNames: 'msgDictionary timeSortedEntries logfile '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!IndexFile commentStamp: '<historical>' prior: 0!
I represent an index for the messages in a mail database. I acts like a dictionary that maps unique message ID's to IndexFileEntry objects.

The index file is read into memory in its entirety and kept there for the duration of a mail reading session. It should be stored back to disk at the end of the session, or after a major change, such as fetching new mail.

If necessary, it can be completely recreated by scanning the messages file!!!

MailDBFile subclass: #MailInboxFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!MailInboxFile commentStamp: '<historical>' prior: 0!
I am a parser for mail inboxes in a form found in the Unix '/var/spool' inboxes. This is also the format used by Eudora 3.0 on the Macintosh (and perhaps by other versions of Eudora as well).
!

MailInboxFile subclass: #MHMailInboxFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!MHMailInboxFile commentStamp: '<historical>' prior: 0!
I am a parser for mail files in the format output by the Unix 'mh' program.
!

Object subclass: #MailNotifier
	instanceVariableNames: 'socket messageCount lastConnectTime password '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!MailNotifier commentStamp: '<historical>' prior: 0!
This is a basic example of connecting to a mail server, using POP3, to check how many messages are waiting.  It does everything at one time, which may make it too slow to use as is.!

MailDBFile subclass: #MessageFile
	instanceVariableNames: 'file '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!MessageFile commentStamp: '<historical>' prior: 0!
I represent the messages file of a mail database. This file is treated as (mostly) append-only. All new messages or edited messages are appended to the end of this file.

Messages are stored as ASCII text with seperator strings and some additional information between each message. If necessary, this file can be inspected or edited with a text editor; after editing, the index file should be recreated using the "compact" command. (This is necessary because the offsets kept in the index file will probably be different after the edits.)

When a message is deleted, its delimiter is changed to mark it as deleted, but it is left in the mail file until the next time "compact" command is executed. Generally, the reduction in disk fragmentation resulting from keeping the messages in a single file more than offsets the temporary space lost by having a few deleted messages hanging around between compactions. Compaction is done into a new copy of the file, followed by a renaming operation. Thus, if compaction fails, the original messages file will not be lost.
!

MailDBFile subclass: #ReadNewsInboxFile
	instanceVariableNames: 'currentNewsgroup msgBuffer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!ReadNewsInboxFile commentStamp: '<historical>' prior: 0!
I am a parser for news files in the format output by the Unix 'readnews' program.
!

ReadNewsInboxFile subclass: #RNInboxFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Mail Reader'!

!RNInboxFile commentStamp: '<historical>' prior: 0!
I am a parser for news files in the format output by the Unix 'rn' program.
!


!Celeste methodsFor: 'open-close' stamp: 'jm 10/4/1998 14:01'!
close
	"Close the mail database."

	userPassword _ nil.
	mailDB ifNotNil: [
		mailDB close; release.
		mailDB _ nil].
! !

!Celeste methodsFor: 'open-close' stamp: 'dvf 11/18/2000 17:06'!
isActive
	^mailDB notNil! !

!Celeste methodsFor: 'open-close' stamp: 'ls 6/21/2001 18:01'!
openDefaultDatabase
	"open the default database, creating it if it isn't present"
	self openOnDatabase: (MailDB openOn: Celeste defaultDBName).
	self changed: #categoryList.! !

!Celeste methodsFor: 'open-close' stamp: 'ls 6/20/2001 23:58'!
openOnDatabase: aMailDB
	"Initialize myself for the mail database with the given root filename."

	mailDB _ aMailDB.
	currentCategory _ 'new'.
	lastCategory _ ''.
	subjectFilter _ ''.
	participantFilter _ ''.
	self setCategory: currentCategory.
! !

!Celeste methodsFor: 'open-close' stamp: 'jm 8/20/1998 18:37'!
windowIsClosing
	"Close the mail database when my window is closed."

	self close.
! !

!Celeste methodsFor: 'drag and drop' stamp: 'mdr 4/12/2001 10:43'!
acceptDroppingMorph: transferMorph event: evt inMorph: dstListMorph 
	"Accept messageIDs from the tocEntryList.  Move the indicated message to the destination category."

	| srcType moveID destCategory savedCurrentMsgID |

	srcType _ transferMorph dragTransferType.
	srcType == #tocEntryList ifFalse: [^false].

	"Get the message ID and the destination category"
	moveID _ transferMorph passenger initialIntegerOrNil.
	destCategory _ dstListMorph potentialDropMorph contents.
	[moveID isKindOf: Integer] assert.
	[self categoryList includes: destCategory] assert.

	"Don't do anything if the message was dropped into some particular categories"
	(destCategory = currentCategory) ifTrue: [^false].	"the current category"
	(destCategory = '.all.') ifTrue: [^false].				"the computed category .all."

	"Quickly remove the message from those displayed using removeMessage:.  And a bit of fiddling to ensure we display the original message or something similar"
	savedCurrentMsgID _ currentMsgID.
	mailDB file: moveID inCategory: destCategory.
	self removeMessage: moveID.
	savedCurrentMsgID = moveID ifFalse: [self displayMessage: savedCurrentMsgID].

	^true! !

!Celeste methodsFor: 'drag and drop' stamp: 'mdr 4/10/2001 17:41'!
dragPassengerFor: item inMorph: dragSource
	"Create a information string representing the message to drag (and display while dragging)"

	| msgID |

	(dragSource isKindOf: PluggableListMorph) ifFalse: [^item].

	dragSource getListSelector == #tocEntryList
		ifTrue: [ msgID _ self msgIDFromTOCEntry: item contents.
				^ msgID printString, ' ', (mailDB getMessage: msgID) from].

	"Give them nil if they try to drag a category for instance"
	^nil! !

!Celeste methodsFor: 'drag and drop' stamp: 'mdr 4/8/2001 20:58'!
dragTransferTypeForMorph: dragSource

	^(dragSource isKindOf: PluggableListMorph)
		ifTrue: [dragSource getListSelector]! !

!Celeste methodsFor: 'drag and drop' stamp: 'mdr 4/8/2001 20:55'!
wantsDroppedMorph: transferMorph event: anEvent inMorph: destinationLM 
	"We are only interested in TransferMorphs as wrappers for             
	informations. If their content is really interesting for us, will             
	determined later in >>acceptDroppingMorph:event:."

	| srcType dstType |

	"only want drops on lists (not, for example, on pluggable texts)"
	(destinationLM isKindOf: PluggableListMorph) ifFalse: [^ false].

	srcType _ transferMorph dragTransferType.
	dstType _ destinationLM getListSelector.

	(srcType = #tocEntryList) ifFalse: [^false].	"Only messages from TOC"
	(dstType = #categoryList) ifFalse: [^false].	"Only drop into category list"

	^true! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 00:07'!
addCategory
	"Create a new category with the user-specified name. This does nothing if the category already exists."

	| newCatName |
	mailDB ifNil: [ ^self ].
	newCatName _ FillInTheBlank request: 'Name for new category?'.
	(newCatName isEmpty) ifTrue: [^self].	"user aborted"

	self requiredCategory: newCatName.
	self setCategory: newCatName.
! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 2/10/2001 10:25'!
cacheTOC
	"Caches a version of the TOC"
	| tocStringColumns |
	self initializeTocLists.

	'Processing ' , currentMessages size printString , ' messages.'
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: currentMessages size
		during: [:bar | 1
				to: currentMessages size
				do: [:i | 
					bar value: i.

					(self tocLists at: 1)
						add: i printString.

					"columns from the database are 5"
					tocStringColumns _ mailDB
								getTOCstringAsColumns: (currentMessages at: i).

					(self tocLists at: 2)
						add: ((tocStringColumns at: 5)
								ifTrue: ['@']
								ifFalse: [' ']).
					(self tocLists at: 3)
						add: (tocStringColumns at: 1).
					(self tocLists at: 4)
						add: (tocStringColumns at: 2).
					(self tocLists at: 5)
						add: (tocStringColumns at: 4).
					(self tocLists at: 6)
						add: (tocStringColumns at: 3)]].

	(currentMessages includes: currentMsgID)
		ifFalse: [currentMsgID _ nil]! !

!Celeste methodsFor: 'categories pane' stamp: 'jm
 8/20/1998 09:24'!
categoriesKeystroke: aCharacter

	aCharacter asciiValue = 30 ifTrue: [self previousCategory].
	aCharacter asciiValue = 31 ifTrue: [self nextCategory].
! !

!Celeste methodsFor: 'categories pane'!
category
	"Answer the currently selected category or nil."

	^currentCategory! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/20/2001 23:59'!
categoryList
	"Answer a list of categories for the categories pane."
	mailDB ifNil: [ ^#() ].
	^ mailDB allCategories
! !

!Celeste methodsFor: 'categories pane' stamp: 'sbw 1/30/2001 21:29'!
categoryMenu: aMenu 
	"Answer the menu for the categories pane."
	aMenu add: 'save' action: #save.
	aMenu balloonTextForLastItem: 'Save the database'.
	aMenu addLine.
	aMenu add: 'fetch mail' action: #fetchMail.
	aMenu balloonTextForLastItem: 'Fetch new mail from the server'.
	aMenu add: 'send queued mail' action: #sendQueuedMail.
	aMenu balloonTextForLastItem: 'Send newly written mail'.
	aMenu addLine.
	aMenu add: 'add category' action: #addCategory.
	aMenu balloonTextForLastItem: 'Add a new organizational category'.
	currentCategory notNil
		ifTrue: [aMenu add: 'view all messages' action: #viewAllMessages.
			aMenu balloonTextForLastItem: 'View all the messages'].
	"add extra commands if a normal category is selected"
	(currentCategory notNil
			and: [currentCategory ~= '.all.' & (currentCategory ~= '.unclassified.')])
		ifTrue: [aMenu add: 'edit category filter' action: #editCategoryFilter.
			aMenu balloonTextForLastItem: 'Edit a custom filter for this category'.
			aMenu add: 'rename category' action: #renameCategory.
			aMenu balloonTextForLastItem: 'Rename this organizational category'.
			aMenu add: 'remove category' action: #removeCategory.
			aMenu balloonTextForLastItem: 'Remove this organizational category
(NB: all messages will be safely available in other categories)'.
			aMenu addLine.
			aMenu add: 'import into category' action: #importIntoCategory.
			aMenu balloonTextForLastItem: 'Import messages from a Unix/Eudora file into this category'.
			aMenu add: 'export category (Celeste)' action: #exportCategory.
			aMenu balloonTextForLastItem: 'Copy all messages from this category to another Celeste database'.
			aMenu add: 'export category (Unix/Eudora)' action: #exportCategoryUnix.
			aMenu balloonTextForLastItem: 'Write a copy of all messages from this category to a Unix/Eudora file'].
	aMenu addLine.
	aMenu add: 'empty trash' action: #emptyTrash.
	aMenu balloonTextForLastItem: 'Completely remove all messages in the category .trash. from Celeste'.
	aMenu add: 'salvage & compact' action: #compact.
	aMenu balloonTextForLastItem: 'Salvage any work done since the last database save & recover space used by old deleted messages.
(This may be a bit slow)'.
	aMenu add: 'find duplicates' action: #findDuplicates.
	aMenu balloonTextForLastItem: 'Find messages which are exact duplicates'.
	aMenu addLine.
	aMenu addUpdating: #suppressingHeadersString action: #toggleSuppressHeaders.
	aMenu balloonTextForLastItem: 'Show either a complete or an easy-to-read message header'.
	aMenu add: 'change max current messages (' , self class messageCountLimit printString , ')' action: #changeMaxMessageCount.
	aMenu addLine.
	aMenu add: 'set user name' action: #setUserName.
	aMenu balloonTextForLastItem: 'Specify the ''From:'' user name for new messages'.
	aMenu add: 'set cc: list' action: #setCCList.
	aMenu balloonTextForLastItem: 'Specify a cc: list that is added to each new message'.
	aMenu add: 'set POP server' action: #setPopServer.
	aMenu balloonTextForLastItem: 'Specify which (POP3) server to check for new messages'.
	aMenu add: 'set POP username' action: #setPopUserName.
	aMenu balloonTextForLastItem: 'Specify the username to use when checking for new messages'.
	aMenu add: 'set SMTP server' action: #setSmtpServer.
	aMenu balloonTextForLastItem: 'Specify which (SMTP) server to use when sending messages'.
	aMenu addLine.
	aMenu addUpdating: #messagesOnServerString action: #toggleKeepMessagesOnServer.
	aMenu balloonTextForLastItem: 'When true, messages are not deleted from the server when you retreive them (typically used for testing only).  When false, messages are deleted from the server after you retreive them'.
	^ aMenu! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 00:07'!
compact
	"Salvage and Compact the messages file."

	| stats |
	mailDB ifNil: [ ^self ].
	Transcript cr; show: 'Compacting message file...'.
	Cursor execute showWhile: [stats _ mailDB compact].
	Transcript show: 'Done.'; cr.
	Transcript show:
		'Recovered ',
		(stats at: 1) printString, ' message',
		(((stats at: 1) = 1) ifTrue: [', '] ifFalse: ['s, ']),
		(stats at: 2) printString, ' bytes.  ',
		(stats at: 3) printString, ' active messages remain.'; cr.

	self setCategory: self category.		"Flush all the displayed state"! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 00:08'!
emptyTrash
	"Delete all messages in the '.trash.' category.
	WARNING: The messages will be totally removed from the Celeste index, and the .messages file will be marked so that the message contents are removed when it is next compressed."

	| msgList |
	mailDB ifNil: [ ^self ].
	self requiredCategory: '.trash.'.

	msgList _ mailDB messagesIn: '.trash.'.			"Look at ALL messages in the trash"
	"Remove from the list messages which are also in other categories"
	msgList _ msgList select: [ :msgID | (mailDB categoriesThatInclude: msgID) size = 1].

	mailDB deleteAll: msgList.
	mailDB cleanUpCategories.
	self updateTOC.

	(mailDB messagesIn: '.trash.') isEmpty ifFalse:
		[self inform: 'Some messages were not removed because they are also filed in other categories'].! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:52'!
exportCategory
	"Store the filtered message list of the current category to another mail database. The user is prompted for the name of the other database."

	| destDBName destDB |
	mailDB ifNil: [ ^self ].
	currentCategory ifNil: [ ^self ].

	destDBName _ FillInTheBlank
		request: 'Destination mail database?'
		initialAnswer: ''.
	(destDBName isEmpty) ifTrue: [^self].
	destDB _ MailDB openOn: destDBName.
	(destDB isNil) ifTrue: [^self].
	destDB mergeMessages: (self filteredMessagesIn: currentCategory) from: mailDB.
	destDB saveDB.
! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:52'!
exportCategoryUnix
	"Store the filtered message list of the current category into a Eudora/Unix database"
	| destFileName destFile messageIds count |
	mailDB ifNil: [ ^self ].
	currentCategory ifNil: [ ^self ].

	destFileName _ FillInTheBlank
		request: 'Destination mail file?'
		initialAnswer: ''.
	(destFileName isEmpty) ifTrue: [^self].
	destFile _ FileStream fileNamed: destFileName.
	destFile ifNil: [ ^self error: 'could not open file' ].
	destFile setToEnd.

	messageIds _ self filteredMessagesIn: currentCategory.

	('exporting ', messageIds size printString, ' messages')
		displayProgressAt: Sensor mousePoint
		from: 0
		to: messageIds size
		during: [ :bar |
			count _ 0.
			messageIds do: [ :messageId |
				destFile nextPutAll: Celeste eudoraSeparator.
				(mailDB getMessage: messageId) text linesDo: [ :line |
					(line beginsWith: 'From ') ifTrue: [ destFile nextPut: $> ].
					destFile nextPutAll: line.
					destFile cr ].
				count _ count + 1.
				bar value: count. ].
		].

	destFile close.
! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 00:08'!
fetchMail
	"Append messages from the user's mailbox to this mail database."

	| server password msgCount |
	mailDB ifNil: [ ^self ].
	server _ self class popServer.
	password _ self popPassword.
	password ifNil: [^ self].

	self requiredCategory: 'new'.

	msgCount _ mailDB fetchMailFromPOP: server
		userName: self class popUserName
		password: password
		doFormatting: FormatWhenFetching
		deleteFromServer: DeleteInboxAfterFetching.
	msgCount < 0
		ifTrue: [self inform: 'could not connect to the mail server']
		ifFalse: [self inform: msgCount printString, ' messages fetched'].
	msgCount <= 0 ifTrue: [^ self].

	self setCategory: 'new'.

! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 00:08'!
findDuplicates
	"Find duplicate messages, and move the redundant copies to a given category."

	| duplicatesCategory |
	mailDB ifNil: [ ^self ].
	duplicatesCategory _ FillInTheBlank
		request: 'File duplicates in category?'
		initialAnswer: '.duplicates.'.
	duplicatesCategory isEmpty ifTrue:[^ self].

	self requiredCategory: duplicatesCategory.

	Utilities informUser: 'Searching for duplicates...'
		during: [mailDB fileDuplicatesIn: duplicatesCategory].

	self setCategory: duplicatesCategory.
! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:52'!
importIntoCategory
	"Add the messages from a Unix or Eudora format file into this category"

	| inboxPath count |
	mailDB ifNil: [ ^self ].
	currentCategory ifNil: [ ^self ].

	"get the file to import from"
	inboxPath _ ''.
	[	inboxPath _ FillInTheBlank request: 'file to import from?\(should be Eudora or Unix format)' withCRs.
		inboxPath isEmpty ifTrue: [ ^self ].
		FileStream isAFileNamed: inboxPath 
	] whileFalse: [
		self inform: 'file does not exist' ].

	Utilities informUser: 'Fetching mail from ', inboxPath during: [
		count _ mailDB importMailFrom: inboxPath  intoCategory: currentCategory. ].
	self inform: count printString, ' messages imported'.

	self updateTOC.! !

!Celeste methodsFor: 'categories pane' stamp: 'sbw 1/30/2001 20:12'!
maxMessagesToDisplay
	"return the maximum number of mesasges to display at one time; the  
	motivation is that huge lists of messages are impractical"
	^ self class messageCountLimit! !

!Celeste methodsFor: 'categories pane' stamp: 'sbw 1/30/2001 20:25'!
messages: actuallyShown from: possible 
	self class includeStatusPane ifTrue: [
	self status: 'Showing ' , actuallyShown printString , ' of ' , possible printString , ' messages in "' , self category , '"']! !

!Celeste methodsFor: 'categories pane' stamp: 'sbw 1/30/2001 21:07'!
messagesOnServerString
	| string |
	string _ 'leave messages on server'.
	^ DeleteInboxAfterFetching 
		ifTrue: ['<no>' , string]
		ifFalse: ['<yes>' , string]! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:49'!
nextCategory
	"Select the next category."

	| catList i |
	mailDB ifNil: [ ^self ].
	catList _ self categoryList.
	(currentCategory isNil) ifTrue: [currentCategory _ catList last].
	i _ catList indexOf: currentCategory.
	i < catList size
		ifTrue: [self setCategory: (catList at: i + 1)]
		ifFalse: [self setCategory: (catList at: 1)].
! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:49'!
previousCategory
	"Select the next category."

	| catList i |
	mailDB ifNil: [ ^self ].
	catList _ self categoryList.
	(currentCategory isNil) ifTrue: [currentCategory _ catList last].
	i _ catList indexOf: currentCategory.
	i > 1
		ifTrue: [self setCategory: (catList at: i - 1)]
		ifFalse: [self setCategory: (catList at: catList size)].
! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:52'!
removeCategory
	"Remove the existing category with the user-specified name."

	| msgList |
	mailDB ifNil: [ ^self ].
	currentCategory ifNil: [ ^self ].

	msgList _ mailDB messagesIn: currentCategory.
	(mailDB messagesIn: '.trash.') do: [: id |
		msgList remove: id ifAbsent: []].
	msgList isEmpty ifFalse: [
		(self confirm:
'This category is not empty. Are
you sure you wish to remove it?') ifFalse: [^self]].
	mailDB removeCategory: currentCategory.

	self changed: #categoryList.
	self setCategory: nil.
! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:52'!
renameCategory
	"Rename the category with the user-specified name."

	| newCatName |
	mailDB ifNil: [ ^self ].
	currentCategory ifNil: [ ^self ].

	newCatName _ FillInTheBlank
		request: 'New name?'
		initialAnswer: currentCategory.
	(newCatName isEmpty) ifTrue: [^self].	"user aborted"
	mailDB renameCategory: currentCategory to: newCatName.
	currentCategory _ newCatName.
	self changed: #categoryList.! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:49'!
save
	"Snapshot the database to disk."
	mailDB ifNil: [ ^self ].
	mailDB saveDB.
! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:49'!
setCCList
	"Change the default cc: list for use in composing messages."
	mailDB ifNil: [ ^self ].
	self class setCCList.! !

!Celeste methodsFor: 'categories pane' stamp: 'RAA 3/14/2001 18:05'!
setCategory: newCategory 
	"Change the currently selected category. We must also compute the table  
	of contents and message list for the new category."
	| messageCount |
	currentCategory _ newCategory.
	newCategory isNil
		ifTrue: [currentMessages _ currentMsgID _ nil.
			self class includeStatusPane
				ifTrue: [status _ nil]]
		ifFalse: [currentMessages _ self filteredMessagesIn: newCategory.
			messageCount _ currentMessages size.
			messageCount > self maxMessagesToDisplay
				ifTrue: [self messages: self maxMessagesToDisplay from: messageCount.
					currentMessages _ currentMessages copyLast: self maxMessagesToDisplay]
				ifFalse: [self messages: messageCount from: messageCount].
			self cacheTOC].
	self changed: #category.
	self changed: #tocEntryList.
	self changed: #tocEntry.
	self changed: #messageText.
	self changed: #status.
	self changed: #outBoxStatus! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:50'!
setPopServer
	mailDB ifNil: [ ^self ].
	^self class setPopServer! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:50'!
setPopUserName
	mailDB ifNil: [ ^self ].
	userPassword _ nil.   "Clear the password when a new username is set"
	^self class setPopUserName! !

!Celeste methodsFor: 'categories pane'!
setSmtpServer
	mailDB ifNil: [ ^self ].
	^MailSender setSmtpServer! !

!Celeste methodsFor: 'categories pane'!
setUserName
	"Change the user's email name for use in composing messages."
	mailDB ifNil: [ ^self ].
	MailSender setUserName.! !

!Celeste methodsFor: 'categories pane' stamp: 'sbw 1/30/2001 21:02'!
suppressingHeadersString
	| string |
	string _ 'suppress header'.
	^ SuppressWorthlessHeaderFields
		ifTrue: ['<yes>' , string]
		ifFalse: ['<no>' , string]! !

!Celeste methodsFor: 'categories pane' stamp: 'sbw 1/30/2001 21:22'!
toggleKeepMessagesOnServer
	DeleteInboxAfterFetching _ DeleteInboxAfterFetching not! !

!Celeste methodsFor: 'categories pane' stamp: 'jm
 8/20/1998 10:35'!
toggleSuppressHeaders

	SuppressWorthlessHeaderFields _ SuppressWorthlessHeaderFields not.
	self changed: #messageText.
! !

!Celeste methodsFor: 'categories pane' stamp: 'ls 6/21/2001 17:50'!
viewAllMessages
	mailDB ifNil: [ ^self ].
	currentMessages _ self filteredMessagesIn: self category.
	self messages: currentMessages size from:  currentMessages size.
	self cacheTOC.
	self changed: #tocEntryList.
	self changed: #tocEntry.
	self changed: #messageText! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:31'!
autoFile
	"automatically pick a folder for the current message, and file the current message there"
	| folder |
	mailDB ifNil: [ ^self ].
	folder := self chooseFilterForCurrentMessage.
	folder ifNil: [ ^self].
	lastCategory := folder.
	mailDB file: currentMsgID inCategory: folder.! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:32'!
autoMove
	"automatically pick a folder for the current message, and move the message there"
	| folder |
	mailDB ifNil: [ ^self ].
	folder := self chooseFilterForCurrentMessage.
	folder ifNil: [ ^self].
	lastCategory := folder.
	mailDB file: currentMsgID inCategory: folder.
	self removeMessage.! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:32'!
deleteAll
	"Move all visible messages in the current category to '.trash.'."

	| |
	mailDB ifNil: [ ^self ].

	self requiredCategory: '.trash.'.
	mailDB fileAll: currentMessages inCategory: '.trash.'.
	self removeAll.! !

!Celeste methodsFor: 'table of contents pane' stamp: 'sbw 2/1/2001 10:25'!
deleteMessage
	"Move the current message to the '.trash.' category and select the next  
	message. Deleted messages can later purged by the 'empty trash' menu  
	item"
	currentMsgID isNil
		ifTrue: [^ self].
	self requiredCategory: '.trash.'.
	mailDB file: currentMsgID inCategory: '.trash.'.
	self removeMessage! !

!Celeste methodsFor: 'table of contents pane' stamp: 'mdr 4/11/2001 14:04'!
displayMessage: msgID
	"If the message is in our displayed category, show it"

	(currentMessages notNil and: [currentMessages includes: msgID])
		ifTrue: [currentMsgID _ msgID]
		ifFalse: [currentMsgID _ nil].

	self changed: #tocEntry.
	self changed: #messageText.


	"Celeste someInstance displayMessage: 671458061"! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:32'!
fileAgain
	"File the current message in the same category as last time."

	| newCatName |
	mailDB ifNil: [ ^self ].
	(lastCategory isEmpty not)
		ifTrue: [newCatName _ lastCategory]
		ifFalse: [newCatName _ self getCategoryNameIfNone: [^self]].
	mailDB file: currentMsgID inCategory: newCatName.
! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:32'!
fileAll
	"File all visible messages in the current category in some other category as well."

	| newCatName msgList |
	mailDB ifNil: [ ^self ].
	newCatName _ self getCategoryNameIfNone: [^self].
	msgList _ self filteredMessagesIn: currentCategory.
	mailDB fileAll: msgList inCategory: newCatName.
	self updateTOC.! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:32'!
fileMessage
	"File the current message in another category."

	| newCatName |
	mailDB ifNil: [ ^self ].
	newCatName _ self getCategoryNameIfNone: [^self].
	mailDB file: currentMsgID inCategory: newCatName.
! !

!Celeste methodsFor: 'table of contents pane' stamp: 'mdr 4/9/2001 21:52'!
getCategoryNameIfNone: aBlock
	"Prompt the user for a category name"

	| catList categoryName categoryMenu |
	catList _ self categoryList.
	catList remove: '.all.' ifAbsent: [].
	catList remove: '.trash.' ifAbsent: [].
	catList remove: '.unclassified.' ifAbsent: [].
	catList add: '<new category>'.
	categoryMenu _ CustomMenu selections: catList.
	categoryName _ categoryMenu startUp.
	categoryName = nil ifTrue: [^aBlock value].
	categoryName = '<new category>' ifTrue: [
		categoryName _ FillInTheBlank
			request: 'New category name?'
			initialAnswer: ''.
		(categoryName isEmpty) ifTrue: [^aBlock value].
		mailDB addCategory: categoryName.
		self changed: #categoryList.
	].
	^lastCategory _ categoryName
! !

!Celeste methodsFor: 'table of contents pane' stamp: 'mdr 8/31/2000 11:47'!
moveAgain
	"Move the current message to the same category as last time."

	| newCatName |

	currentMsgID ifNil: [ ^self ].
	(lastCategory isEmpty not)
		ifTrue: [newCatName _ lastCategory]
		ifFalse: [newCatName _ self getCategoryNameIfNone: [^self]].
	newCatName = currentCategory ifTrue: [ ^self ].

	mailDB file: currentMsgID inCategory: newCatName.
	self removeMessage.! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:33'!
moveAll
	"Move all visible messages in the current category to another category."

	| newCatName |
	mailDB ifNil: [ ^self ].
	newCatName _ self getCategoryNameIfNone: [^self].
	newCatName = currentCategory ifTrue:[ ^self ].
	mailDB fileAll: currentMessages inCategory: newCatName.

	self removeAll.! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:33'!
moveMessage
	"Move the current message to another category; this consists of filing it in the new category, and then removing it from the current category"

	| newCatName |
	mailDB ifNil: [ ^self ].
	newCatName _ self getCategoryNameIfNone: [^self].
	newCatName = currentCategory ifTrue: [ ^self ].
	mailDB file: currentMsgID inCategory: newCatName.

	self removeMessage.
! !

!Celeste methodsFor: 'table of contents pane' stamp: 'mdr 4/8/2001 20:18'!
msgIDFromTOCEntry: newTOCentry 
	"Given an entry index number from the TOC pane, find the corresponding msgID"

	^currentMessages at: ((self tocLists at: 1) indexOf: newTOCentry ifAbsent: [^nil])
! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:33'!
nextMessage
	"Select the next message."

	| index |
	mailDB ifNil: [ ^self ].
	(currentCategory isNil | currentMsgID isNil) ifTrue: [^ self].
	index _ currentMessages indexOf: currentMsgID.
	index < currentMessages size
		ifTrue: [self setTOCEntry: ((self tocLists at: 1) at: index + 1)]
		ifFalse: [self setTOCEntry: ((self tocLists at: 1) at: 1)].
! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:33'!
otherCategories
	"Prompt the user with a menu of all other categories in which the currently selected message appears. If the user chooses a category from this menu, go to that category."

	| otherCategories choice |
	mailDB ifNil: [ ^self ].
	otherCategories _
		(mailDB categoriesThatInclude: currentMsgID) asOrderedCollection.
	otherCategories remove: currentCategory ifAbsent: [].
	(otherCategories isEmpty) ifTrue: [^self].
	choice _ (CustomMenu selections: otherCategories) startUp.
	choice = nil ifFalse: [self setCategory: choice].! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:33'!
partsMenu
	"Show a menu listing all the parts of this message, and let the user save the chosen part to a file"

	| menu currMessage part |
	currentMsgID ifNil: [ ^self ].
	menu _ CustomMenu new.
	currMessage _ self currentMessage.
	currMessage atomicParts do: [:e | menu add: 'save ' , e printString action: e].
	part _ menu startUp.
	part ifNotNil: [part save]! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:33'!
previousMessage
	"Select the previous message."

	| index |
	mailDB ifNil: [ ^self ].
	(currentCategory isNil | currentMsgID isNil) ifTrue: [^ self].
	index _ currentMessages indexOf: currentMsgID.
	index > 1
		ifTrue: [self setTOCEntry: ((self tocLists at: 1)  at: index - 1)]
		ifFalse: [self setTOCEntry: ((self tocLists at: 1)  at: currentMessages size)].

! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:33'!
removeAll
	"Remove all presently listed messages from the current category."
	mailDB ifNil: [ ^self ].
	mailDB removeAll: currentMessages fromCategory: currentCategory.
	currentMsgID _ nil.

	"Regenerate the (possibly empty) TOC for this category"
	self setCategory: currentCategory.
! !

!Celeste methodsFor: 'table of contents pane' stamp: 'mdr 4/11/2001 14:33'!
removeMessage
	self removeMessage: currentMsgID! !

!Celeste methodsFor: 'table of contents pane' stamp: 'mdr 4/11/2001 14:46'!
removeMessage: msgID
	"Remove the message from the current category and update the display.  This is done in a way that avoids having to regenerate the TOC list and thus is pretty fast"

	| currentMessageIndex |

	msgID ifNil: [^ self].
	[currentMessages includes: msgID] assert.

	mailDB remove: msgID fromCategory: currentCategory.

	"remove the message from the listing"
	currentMessageIndex _ currentMessages indexOf: msgID.
	currentMessages _ currentMessages copyWithout: msgID.

	2
		to: self tocLists size
		do: [:index | (tocLists at: index) removeAt: currentMessageIndex].
	tocLists first removeLast.

	"update the message index and message ID"
	msgID = currentMsgID ifTrue: [
		currentMessages isEmpty
			ifTrue: [currentMsgID _ nil]
			ifFalse: [currentMsgID _ currentMessages
						at: (currentMessageIndex min: currentMessages size)]].
	currentMsgID ifNotNil: [[currentMessages includes: currentMsgID] assert].

	self changed: #tocEntryList.
	self changed: #tocEntry.
	self changed: #messageText.
	self changed: #status.
	self changed: #outBoxStatus! !

!Celeste methodsFor: 'table of contents pane' stamp: 'dvf 4/27/2000 00:14'!
saveMessage
	"save the currently selected message to a file"
	| fileName file |
	currentMsgID ifNil: [^ self].
	fileName _ FillInTheBlank request: 'file to save in'.
	fileName isEmpty ifTrue: [^ self].
	file _ FileStream fileNamed: fileName.
	file nextPutAll: (self currentMessage) text.
	file close! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:34'!
search
	"Search the text of all messages in the present category"

	| destCat matchString msgText |
	mailDB ifNil: [ ^self ].
	destCat _ FillInTheBlank
		request: 'In what category should the search results be filed?'
		initialAnswer: '.search results.'.
	(destCat isEmpty) ifTrue: [^self].
	matchString _ FillInTheBlank
		request: 'String sought in message text?'
		initialAnswer: ''.
	(matchString isEmpty) ifTrue: [^self].

	self requiredCategory: destCat.

	(self filteredMessagesIn: currentCategory) do:
		[: msgID |
		 msgText _ mailDB getText: msgID.
		 ((msgText findString: matchString startingAt: 1) > 0) ifTrue:
			[mailDB file: msgID inCategory: destCat]].

	self setCategory: destCat.

! !

!Celeste methodsFor: 'table of contents pane' stamp: 'mdr 4/8/2001 20:31'!
setTOCEntry: newTOCentry 
	"Change the currently selected message. This is done by finding the  
	message ID corresponding to the selected table of contents entry."

	currentMsgID _ self msgIDFromTOCEntry: newTOCentry. 
	self changed: #tocEntry.
	Cursor read
		showWhile: [self changed: #messageText]! !

!Celeste methodsFor: 'table of contents pane' stamp: 'sbw 1/28/2001 23:18'!
tocEntry
	"Answer the table of contents entry for the currently selected message  
	or nil."
	currentMsgID isNil
		ifTrue: [^ nil]
		ifFalse: [^ (self tocLists at: 1)
				at: (currentMessages indexOf: currentMsgID)]! !

!Celeste methodsFor: 'table of contents pane' stamp: 'sbw 1/28/2001 23:18'!
tocEntryList
	currentCategory isNil
		ifTrue: [self initializeTocLists].
	self tocLists == nil
		ifTrue: [self initializeTocLists].
	^ self tocLists! !

!Celeste methodsFor: 'table of contents pane' stamp: 'dvf 7/1/2000 15:24'!
tocKeystroke: aCharacter 
	aCharacter = Character backspace
		ifTrue: [self deleteMessage].
	aCharacter asciiValue = 30
		ifTrue: [self previousMessage].
	aCharacter asciiValue = 31
		ifTrue: [self nextMessage].
	aCharacter = $c
		ifTrue: [self customFilterOn].
	aCharacter = $m
		ifTrue: [self customFilterMove].
	aCharacter = $s
		ifTrue: [self subjectFilterOn]
! !

!Celeste methodsFor: 'table of contents pane' stamp: 'mdr 4/10/2001 16:44'!
tocMenu: aMenu 
	"Answer the menu for the table of contents pane."
	| messageSelected autoFolder |
	currentCategory ifNil: [^ nil].
	messageSelected _ currentMsgID isNil not.
	messageSelected
		ifTrue: 
			[aMenu add: 'delete' action: #deleteMessage.
			aMenu balloonTextForLastItem: 'Move this message to the .trash. category'.
			aMenu addLine.
			aMenu add: 'compose' action: #compose.
			aMenu balloonTextForLastItem: 'Compose a new message'.
			aMenu add: 'reply' action: #reply.
			aMenu balloonTextForLastItem: 'Reply to this message'.
			aMenu add: 'forward' action: #forward.
			aMenu balloonTextForLastItem: 'Forward this message'.
			self currentMessage body isMultipart
				ifTrue: 
					[aMenu add: 'parts...' action: #partsMenu.
					aMenu balloonTextForLastItem: 'Forward this message'].
			aMenu addLine.
			lastCategory isEmpty
				ifFalse: 
					[aMenu add: 'file -> ' , lastCategory action: #fileAgain.
					aMenu balloonTextForLastItem: 'Add this message also to the category ' , lastCategory.
					aMenu add: 'move -> ' , lastCategory action: #moveAgain.
					aMenu balloonTextForLastItem: 'Move this message to the category ' , lastCategory.
					aMenu addLine].
			autoFolder := self chooseFilterForCurrentMessage.
			autoFolder ifNotNil: [
				aMenu add: ('file -> ', autoFolder) action: #autoFile.
				aMenu balloonTextForLastItem: 'Add this message also to the (automatically selected) category ' , autoFolder.
				aMenu add: ('move -> ', autoFolder) action: #autoMove.
				aMenu balloonTextForLastItem: 'Move this message to the (automatically selected) category ' , autoFolder.
				aMenu addLine ].

			aMenu add: 'file' action: #fileMessage.
			aMenu balloonTextForLastItem: 'Add this message also to a different category'.
			aMenu add: 'move' action: #moveMessage.
			aMenu balloonTextForLastItem: 'Move this message to a different category'.
			aMenu add: 'remove' action: #removeMessage.
			aMenu balloonTextForLastItem: 'Remove this message from this category
(NB: the message will be safely available in another category)'.
			aMenu addLine]
		ifFalse: 
			[aMenu add: 'compose' action: #compose.
			aMenu balloonTextForLastItem: 'Compose a new message'.
			aMenu addLine].

	"The following are common for all menus"
	aMenu add: 'file all' action: #fileAll.
	aMenu balloonTextForLastItem: 'Add all messages also to another category'.
	aMenu add: 'move all' action: #moveAll.
	aMenu balloonTextForLastItem: 'Move all messages to another category'.
	aMenu add: 'remove all' action: #removeAll.
	aMenu balloonTextForLastItem: 'Remove all messages from this catgegory
(NB: each message will be safely available in other categories)'.
	aMenu add: 'delete all' action: #deleteAll.
	aMenu balloonTextForLastItem: 'Move all messages to the .trash. category'.
	aMenu addLine.
	messageSelected
		ifTrue: 
			[aMenu add: 'other categories' action: #otherCategories.
			aMenu balloonTextForLastItem: 'Check which other categories also contain this message'.
			aMenu add: 'save message' action: #saveMessage.
			aMenu balloonTextForLastItem: 'Save this message'.
			aMenu addLine].
	self tocEntryList size = self maxMessagesToDisplay ifTrue: [
		"the test above is not exactly correct, but is usually correct."
		aMenu add: 'view all messages' action: #viewAllMessages.
		aMenu balloonTextForLastItem: 'View all messages that match the current filters,	even if there are many thousands of such messages'. ].

	aMenu add: 'search' action: #search.
	aMenu balloonTextForLastItem: 'Search all messages in this category for something'.
	^ aMenu! !

!Celeste methodsFor: 'table of contents pane' stamp: 'ls 6/21/2001 17:34'!
updateTOC
	"Update the table of contents after a moving, removing, or deleting a message.
	Select a message near the removed message in the table of contents if possible."

	| savedMsgID |
	mailDB ifNil: [ ^self ].
	savedMsgID _ currentMsgID.

	"update the TOC listing without displaying any particular message"
	currentMsgID _ nil.
	self setCategory: currentCategory.

	self displayMessage: savedMsgID.

	"NB: self changed: #tocEntryList is already done above by setCategory: and can be slow"
	self changed: #outBoxStatus! !

!Celeste methodsFor: 'filtering' stamp: 'dvf 6/17/2000 22:19'!
chooseFilterFor: msgID from: filterNames
	| res |
	res _ self filtersFor: msgID from: filterNames.
	res isEmpty ifTrue:[^nil].
	res size = 1 ifTrue: [^res anyOne].
	^self selectFilterFrom: res ! !

!Celeste methodsFor: 'filtering' stamp: 'ls 2/10/2001 14:26'!
chooseFilterForCurrentMessage
	"automatically choose a filter to move the selected message.  Returns nil if there isn't a message selected, or if there isn't exactly 1 matching filter"
	| matchingFilters |
	currentMsgID ifNil: [ ^nil ].
	matchingFilters := self filtersFor: currentMsgID from: self filterNames.
	matchingFilters size = 1
		ifTrue: [ ^matchingFilters anyOne ]
		ifFalse: [ ^nil ]! !

!Celeste methodsFor: 'filtering' stamp: 'dvf 6/17/2000 22:28'!
customFilterMove
	"Select or define and activate a custom filter."
	| filterList filterName msgList |
	filterList _ CustomFilters keys select: [:e | self categoryList includes: e].

	filterName _ currentMsgID ifNil: [self selectFilterFrom: filterList] ifNotNil: [self chooseFilterFor: currentMsgID from: filterList].
	((filterName isNil or: [filterName isEmpty]) or: [filterName = 'none']) ifTrue: [^ self].
	customFilterBlock _ self customFilterNamed: filterName.
	msgList _ self filteredMessagesIn: currentCategory.
	mailDB removeAll: msgList fromCategory: currentCategory.
	mailDB fileAll: msgList inCategory: filterName.
	customFilterBlock _ nil.
	self updateTOC! !

!Celeste methodsFor: 'filtering' stamp: 'ls 2/10/2001 10:16'!
customFilterNamed: filterName
 	^CustomFiltersCompiled at: filterName! !

!Celeste methodsFor: 'filtering' stamp: 'ls 6/21/2001 17:34'!
customFilterOff
	"Cancel custom filtering."
	mailDB ifNil: [ ^self ].
	customFilterBlock ifNil: [
		"it's already turned off"
		^self ].

	customFilterBlock _ nil.
	self updateTOC.
	self changed: #isCustomFilterOn.! !

!Celeste methodsFor: 'filtering' stamp: 'ls 6/21/2001 17:34'!
customFilterOn
	"Select or define and activate a custom filter."

	| filterName filterMenu |
	mailDB ifNil: [ ^self ].
	filterMenu := CustomMenu new.

	currentMsgID ifNotNil: [
		(self filtersFor: currentMsgID from: self filterNames) do: [ :name |
			filterMenu add: name action: name ].
		filterMenu addLine.].

	filterMenu add: '(none)' action: #none.
	filterMenu add: '<define new filter...>' action: #define.
	filterMenu add: '<edit exising filter...>' action: #edit.
	filterMenu add: '<delete a filter...>' action: #delete.
	filterMenu addLine.

	self filterNames do: [ :name |
		filterMenu add: name action: name ].

	filterName _ filterMenu startUpWithCaption: 'Select a filter:'.

	filterName ifNil: [ ^self ].
	filterName = #none ifTrue: [^self customFilterOff ].
	filterName = #delete ifTrue: [ ^self deleteFilter].
	filterName = #edit
		ifTrue: [filterName _ self editFilter]
		ifFalse: [
			filterName = #define
				ifTrue: [filterName _ self defineFilter] ].
	filterName ifNil: [ ^self ].
	filterName isEmpty ifTrue: [^self].

	customFilterBlock _ CustomFiltersCompiled at: filterName.

	self updateTOC.
	self changed: #isCustomFilterOn.! !

!Celeste methodsFor: 'filtering' stamp: 'ls 6/21/2001 17:34'!
defineFilter
	| filterName |
	mailDB ifNil: [ ^self ].
	filterName _ FillInTheBlank request: 'Filter name?'.
	filterName isEmpty ifTrue: [^ ''].
	^self editFilterNamed: filterName ! !

!Celeste methodsFor: 'filtering' stamp: 'ls 6/21/2001 17:35'!
deleteFilter

	| filterName |
	mailDB ifNil: [ ^self ].
	CustomFilters isEmpty ifTrue: [^''].

	filterName _ (CustomMenu selections: self filterNames)
		startUpWithCaption: 'Filter to delete?'.
	filterName = nil ifTrue: [^''].
	CustomFilters removeKey: filterName ifAbsent: [].
	CustomFiltersCompiled removeKey: filterName ifAbsent: [].! !

!Celeste methodsFor: 'filtering' stamp: 'ls 6/21/2001 17:35'!
editCategoryFilter
	mailDB ifNil: [ ^self ].
	self editFilterNamed: currentCategory! !

!Celeste methodsFor: 'filtering' stamp: 'ls 6/21/2001 17:35'!
editFilter

	| filterName |
	mailDB ifNil: [ ^self ].
	CustomFilters isEmpty ifTrue: [^''].

	filterName _ (CustomMenu selections: self filterNames)
		startUpWithCaption: 'Filter to edit?'.
	filterName = nil ifTrue: [^''].
	^self editFilterNamed: filterName filterExpr: (CustomFilters at: filterName)! !

!Celeste methodsFor: 'filtering' stamp: 'dvf 6/4/2000 00:47'!
editFilterNamed: filterName
	| expr |
	(CustomFilters includesKey: filterName)
		ifTrue: [expr _ CustomFilters at: filterName]
		ifFalse: [expr _ ''].
	^ self editFilterNamed: filterName filterExpr: expr! !

!Celeste methodsFor: 'filtering' stamp: 'mdr 4/10/2001 15:23'!
editFilterNamed: filterName filterExpr: oldExpr

	| newDefinition |
	newDefinition _ FillInTheBlank
		request:
'Enter a filter definition where "m" is the message being testing. The expression can send
"fromHas:", "toHas:", "ccHas:", "subjectHas:", "participantHas:", or "textHas:" to m to test for
inclusion of a string--or one of an array of strings--in a field. It can also test m''s time
and/or date, the textLength and can combine several tests with logical operators. Examples:
 
     m fromHas: ''johnm''                       -- messages from johnm
     m participantHas: ''johnm''                -- messages from, to, or cc-ing johnm
     m textHas: #(squeak smalltalk java)      -- messages with any of these words
     m subjectHas: #(0 1 2 3 4 5 6 7 8 9)       -- numbers in lists treated as strings
     m textLength > 50000                        -- message bodies larger than 50000 characters 
 
NOTE: "textHas:" is very slow, since it must read the message from disk.'
		initialAnswer: oldExpr.
	newDefinition isEmpty ifTrue: [^''].
	CustomFilters at: filterName put: newDefinition.
	CustomFiltersCompiled at: filterName put: (self class makeFilterFor: newDefinition).
	^filterName! !

!Celeste methodsFor: 'filtering' stamp: 'ls 2/10/2001 14:18'!
filterNames
	"return a sorted list of custom filter names"
	^CustomFilters keys asSortedArray! !

!Celeste methodsFor: 'filtering' stamp: 'ls 6/20/2001 23:57'!
filteredMessagesIn: categoryName

	| msgList |
	mailDB ifNil: [ ^#() ].

	msgList _ mailDB messagesIn: categoryName.

	(participantFilter size > 0) ifTrue:
		[msgList _ msgList select:
			[: id | (mailDB getTOCentry: id) participantHas: participantFilter ]].

	(subjectFilter size > 0) ifTrue:
		[msgList _ msgList select:
			[: id | (mailDB getTOCentry: id) subject includesSubstring: subjectFilter caseSensitive: false]].

	"We do custom filters last so they have to apply to the smallest number of messages"
	(customFilterBlock notNil) ifTrue:
		[msgList _ msgList select:
			[: id | customFilterBlock value: (mailDB getTOCentry: id) ]].

	^msgList! !

!Celeste methodsFor: 'filtering' stamp: 'ls 1/27/2001 17:24'!
filtersFor: msgID from: filterNames
	| currentTocEntry |
	currentTocEntry := mailDB getTOCentry: msgID.
	^filterNames select: [:e | (self customFilterNamed: e) value: currentTocEntry].! !

!Celeste methodsFor: 'filtering' stamp: 'ls 10/15/1998 14:57'!
isCustomFilterOn
	"whether there is a custom filter in effect"
	^customFilterBlock ~~ nil! !

!Celeste methodsFor: 'filtering' stamp: 'ls 1/27/2001 18:25'!
isParticipantFilterOn
	"return whether a non-trivial participant filter is installed"
	^participantFilter notNil and: [ participantFilter isEmpty not ]! !

!Celeste methodsFor: 'filtering' stamp: 'mdr 3/15/2001 15:49'!
isSubjectFilterOn
	"whether there is a subject filter in effect"
	^ subjectFilter isEmptyOrNil not! !

!Celeste methodsFor: 'filtering' stamp: 'dvf 6/17/2000 22:06'!
makeFilterFor: filterExpr
 ^Compiler evaluate: '[ :m | ', filterExpr, ']'.
! !

!Celeste methodsFor: 'filtering' stamp: 'mdr 3/21/2001 15:02'!
normalizedSubject: srcString
	"Turn the raw subject line into a decent possible subject filter"

	| res |
	res _ srcString.

	"Remove leading Re:s"
	[res asLowercase beginsWith: 're:']
		whileTrue: [res _ (res copyFrom: 4 to: res size) withBlanksTrimmed].

	^ res! !

!Celeste methodsFor: 'filtering' stamp: 'ls 6/21/2001 17:35'!
participantFilterOn
	"Show only those messages where a specified user is either the sender or a receiver."
	mailDB ifNil: [ ^self ].
	participantFilter _
		(currentMsgID isNil)
			ifTrue: ['']
			ifFalse: [(mailDB getTOCentry: currentMsgID) from].
	participantFilter _ FillInTheBlank
		request: '''Participant:'' filter pattern?'
		initialAnswer: participantFilter.

	participantFilter _ participantFilter withBlanksTrimmed.
	self updateTOC.
	self changed: #isParticipantFilterOn.! !

!Celeste methodsFor: 'filtering' stamp: 'dvf 6/17/2000 22:24'!
selectFilterFrom: filters
	| filterName filterList |
	filterList _ filters asSortedCollection asOrderedCollection.
	filterList addFirst: '(none)'.
	filterList addLast: '<define new filter...>'.
	filterList addLast: '<edit exising filter...>'.
	filterList addLast: '<delete a filter...>'.
	filterName _ (CustomMenu selections: filterList)
			startUpWithCaption: 'Select a filter:'.
	(filterName isNil or: [filterName isEmpty]) ifTrue: [ ^nil ].
	filterName = '(none)' ifTrue: [^'none'].
	filterName = '<delete a filter...>' ifTrue: [ ^self deleteFilter].
	filterName = '<edit exising filter...>'
		ifTrue: [filterName _ self editFilter]
		ifFalse: [
			filterName = '<define new filter...>'
				ifTrue: [filterName _ self defineFilter]].
	^filterName! !

!Celeste methodsFor: 'filtering' stamp: 'ls 6/21/2001 17:35'!
subjectFilterOn
	"Show only those messages whose subject matches the currently selected  
	message. The user is given a chance to edit the pattern string used to match  
	'Subject:' fields."
	mailDB ifNil: [ ^self ].
	subjectFilter _ currentMsgID isNil
				ifTrue: ['']
				ifFalse: [(mailDB getTOCentry: currentMsgID) subject].
	subjectFilter _ self normalizedSubject: subjectFilter.
	subjectFilter _ FillInTheBlank request: '''Subject:'' filter pattern?' initialAnswer: subjectFilter.
	self updateTOC.
	self changed: #isSubjectFilterOn! !

!Celeste methodsFor: 'message text pane' stamp: 'ls 6/21/2001 17:35'!
compose
	"Make a MailSendTool for composing a new message."
	mailDB ifNil: [ ^self ].
	self openSender: self composeText.! !

!Celeste methodsFor: 'message text pane' stamp: 'ls 9/14/1998 22:23'!
doItContext
	^nil! !

!Celeste methodsFor: 'message text pane' stamp: 'ls 6/21/2001 18:01'!
doItReceiver
	^self! !

!Celeste methodsFor: 'message text pane' stamp: 'ls 6/21/2001 17:35'!
format
	mailDB ifNil: [ ^self ].
	messageTextView
		editString: self formatedMessageText;
		hasUnacceptedEdits: true.
! !

!Celeste methodsFor: 'message text pane' stamp: 'dvf 4/27/2000 00:14'!
formatedMessageText
	"Answer a string that is my formatted mail message."
	| message header body bodyText |
	currentMsgID isNil ifTrue: [^ ''].
	message _ self currentMessage.
	header _ message cleanedHeader.
	body _ message body.
	body contentType = 'text/html'
		ifTrue: [bodyText _ (HtmlParser parse: (ReadStream on: body content)) formattedText]
		ifFalse: [bodyText _ body content].
	^ header asText , String cr , bodyText! !

!Celeste methodsFor: 'message text pane' stamp: 'ls 9/13/1998 02:57'!
forward
	"Make a MailSendTool for forwarding the current message."

	(currentMsgID notNil) ifTrue:
		[self openSender: (self forwardTextFor: currentMsgID)].! !

!Celeste methodsFor: 'message text pane' stamp: 'ls 6/21/2001 18:00'!
message
	"Answer the text of the currently selected message or nil if there isn't one."
self isThisEverCalled .
	(currentMsgID isNil)
		ifTrue: [^'']
		ifFalse: [^(mailDB getText: currentMsgID) asText]! !

!Celeste methodsFor: 'message text pane' stamp: 'jm
 8/20/1998 11:28'!
messageMenu: aMenu shifted: shifted
	"Use the standard text menu."

	^ StringHolder basicNew codePaneMenu: aMenu shifted: shifted
! !

!Celeste methodsFor: 'message text pane' stamp: 'ls 6/21/2001 18:02'!
messageText
	"Answer the text which makes up the complete message (header+body)"
	mailDB ifNil: [ ^self messageTextIfNoDB ].
	(currentMsgID isNil) ifTrue: [^''].

	"Always show the full message header for messages in the category .tosend. so that all special header lines are preserved, shown and can be edited."
	(currentCategory = '.tosend.')
		ifTrue: [^ mailDB getText: currentMsgID].

	SuppressWorthlessHeaderFields
		ifTrue: [^ self currentMessage formattedText]
		ifFalse: [^ mailDB getText: currentMsgID].
! !

!Celeste methodsFor: 'message text pane' stamp: 'bf 3/9/2000 17:54'!
messageText: aStringOrText

	currentCategory isNil | currentMsgID isNil ifTrue: [^ self].
	mailDB newText: aStringOrText asString squeakToIso for: currentMsgID.
	self updateTOC.  "in case the message header was changed"
	messageTextView hasUnacceptedEdits: false.
	self changed: #messageText.
	^ true
! !

!Celeste methodsFor: 'message text pane' stamp: 'ls 6/21/2001 18:11'!
messageTextIfNoDB
	"return text to display to the user if there is no DB opened"
	| openCommand |
	openCommand := 'OPEN' asText.
	openCommand addAttribute: (PluggableTextAttribute evalBlock: [ self openDefaultDatabase ]).
	openCommand addAttribute: (TextColor blue).


	^'No DB is currently open.  Press ' asText, openCommand, ' to open the default database.'! !

!Celeste methodsFor: 'message text pane' stamp: 'jm 8/14/1998 15:13'!
messageTextView: aView

	messageTextView _ aView.
! !

!Celeste methodsFor: 'message text pane' stamp: 'ls 9/13/1998 03:08'!
reply
	"Make a MailSendTool for replying to the current message."

	(currentMsgID notNil) ifTrue:
		[self openSender: (self replyTextFor: currentMsgID)].! !

!Celeste methodsFor: 'other' stamp: 'ls 6/21/2001 17:36'!
changeMaxMessageCount
	| countString count |
	mailDB ifNil: [ ^self ].
	countString _ FillInTheBlank request: 'Maximum number of messages displayed?' initialAnswer: self class messageCountLimit printString.
	countString isEmpty
		ifTrue: [^ self].
	count _ countString asInteger max: 1.
	self class messageCountLimit: count.
	self setCategory: currentCategory! !

!Celeste methodsFor: 'other' stamp: 'jm 8/14/1998 15:26'!
clearUserEditFlag

	messageTextView hasUnacceptedEdits: false.
! !

!Celeste methodsFor: 'other' stamp: 'dvf 4/27/2000 00:12'!
currentMessage
	^mailDB getMessage: currentMsgID! !

!Celeste methodsFor: 'other' stamp: 'jm
 8/20/1998 08:14'!
okToChange
	"This message is sent when changing the selection in either the message cateory or message list panes. Eventually, this should ask the user if it is okay to throw away and unaccepted edits of the current message. For now, it always gives permission."

	currentCategory isNil | currentMsgID isNil ifTrue: [
		"no message selected; discard edits in message pane silently"
		messageTextView hasUnacceptedEdits: false.
		^ true].

	messageTextView hasUnacceptedEdits ifFalse: [^ true].
	(CustomMenu confirm: 'Discard changes to currently selected message?')
		ifTrue: [messageTextView hasUnacceptedEdits: false. ^ true]
		ifFalse: [^ false].
! !

!Celeste methodsFor: 'other' stamp: 'ls 6/20/2001 23:59'!
outBoxStatus
	| outgoing |
	outgoing _ mailDB ifNil: [ #() ] ifNotNil: [ mailDB messagesIn: '.tosend.' ].
	outgoing isEmpty
		ifTrue: [^ 'no mail to be sent'].
	^ 'messages in queue: ' , outgoing size printString! !

!Celeste methodsFor: 'other' stamp: 'di 10/27/1999 08:48'!
perform: selector orSendTo: otherTarget
	"Celeste handles all menu commands."

	selector = #format ifTrue: [^ self perform: selector].

	((#(yellowButtonActivity shiftedYellowButtonActivity) includes: selector) or:
		[(ParagraphEditor yellowButtonMessages includes: selector) or:
		[ParagraphEditor shiftedYellowButtonMenu selections includes: selector]])
			ifTrue: [otherTarget perform: selector]
			ifFalse: [self perform: selector].
! !

!Celeste methodsFor: 'other' stamp: 'mdr 11/22/1999 13:29'!
requiredCategory: catName
	"catName is a required category.  If it does not exist in the database, then create it, and update the category list to reflect that it now exists."

	(self categoryList includes: catName)
		ifFalse:
			[mailDB addCategory: catName.
			self changed: #categoryList.]

! !

!Celeste methodsFor: 'other' stamp: 'dvf 4/26/2000 20:58'!
status
	^ status! !

!Celeste methodsFor: 'other' stamp: 'sge 5/29/2000 20:29'!
status: aStringOrNil
	status _ aStringOrNil.
	self changed: #status! !

!Celeste methodsFor: 'sending mail'!
composeText
	"Answer the template for a new message."

	^ String streamContents: [:str |
		str nextPutAll: 'From: '.
		str nextPutAll: MailSender userName; cr.

		str nextPutAll: 'To: '; cr.
		str nextPutAll: 'Subject: '; cr.

		Celeste ccList isEmpty ifFalse: [
			str nextPutAll: 'Cc: '.
			str nextPutAll: Celeste ccList; cr].
		str cr].
! !

!Celeste methodsFor: 'sending mail'!
forwardTextFor: msgID
	"Answer the template for forwarding the message with the given ID."
	| msg separator |
	msg := self currentMessage.

	^String streamContents: [ :str |
		"From header"
		str nextPutAll: 'From: ';
		nextPutAll: MailSender userName; cr.

		"Put a blank To"
		str nextPutAll: 'To: '; cr.

		"Add a subject modified from the original"
		str nextPutAll: 'Subject: (fwd) '.
		str nextPutAll: msg subject.
		str cr.


		"Add auto-cc if it's been set"
		Celeste ccList isEmpty ifFalse: [
			str nextPutAll: 'Cc: '.
			str nextPutAll: Celeste ccList; cr].

		"add the mime headers to make it multi-part"
		separator := MailMessage generateSeparator.
		str nextPutAll: 'MIME-Version: 1.0'; cr.
		str nextPutAll: 'Content-type: multipart/mixed; boundary="'.
		str nextPutAll: separator; nextPut: $".
		str cr.

		"skip down to the main part of the message"
		str cr.
		str nextPutAll: '--'; nextPutAll: separator; cr.
		str nextPutAll: 'Content-type: text/plain'; cr; cr.

		"insert the forwarded message"
		str cr; cr; nextPutAll: '====forwarded===='; cr; cr.
		str nextPutAll: '--'; nextPutAll: separator; cr.
		str nextPutAll: 'Content-type: message/rfc822'; cr; cr.
		str nextPutAll: msg text; cr.

		"final separator"
		str nextPutAll: '--'; nextPutAll: separator; nextPutAll: '--'; cr.
	].! !

!Celeste methodsFor: 'sending mail' stamp: 'ls 10/16/1998 09:09'!
openSender: initialText
	CelesteComposition openForCeleste: self  initialText: initialText.! !

!Celeste methodsFor: 'sending mail' stamp: 'mdr 3/20/2001 18:24'!
popPassword
	"Answer the password to use when retrieving mail via POP3. The password is stored in an instance variable, which disappears when you close the Celeste window."

	userPassword ifNotNil: [^ userPassword].
	userPassword _ FillInTheBlank requestPassword: 'POP password'.
	userPassword isEmpty ifTrue: [userPassword _ nil].

	^ userPassword
! !

!Celeste methodsFor: 'sending mail' stamp: 'mdr 11/22/1999 15:55'!
preSendAuthentication
	"Where required, authenticate ourselves to the SMTP server before sending mail"

	"This is a placeholder for any required authentication"! !

!Celeste methodsFor: 'sending mail' stamp: 'mdr 3/19/2001 10:39'!
queueMessageWithText: aStringOrText 
	"Queue a message to be sent later. The message is added to the database  
	and filed in the '.tosend.' category."

	| messageText id msg |

	messageText _ 'X-Mailer: ' , Celeste versionString , String cr , 'Date: ' , MailMessage dateStampNow , ' ' , self timeZoneString , ' ' , String cr.
	messageText _ messageText , aStringOrText asString.

	msg _ MailMessage from: messageText.

	"Check now that the addresses are well formed email addresses.  This prevents
	runtime errors when actually transmitting the mail"
	[MailAddressParser addressesIn: msg from] ifError:
		[ :err :rcvr | self inform: 'From: in message header', String cr, err. ^nil].
	[MailAddressParser addressesIn: msg to] ifError:
		[ :err :rcvr | self inform: 'To: in message header', String cr, err. ^nil].
	[MailAddressParser addressesIn: msg cc] ifError:
		[:err :rcvr | self inform: 'CC: in message header', String cr, err. ^nil].

	"queue the message"
	self requiredCategory: '.tosend.'.
	id _ mailDB addNewMessage: msg.
	mailDB file: id inCategory: '.tosend.'.
	self category = '.tosend.'
		ifTrue: [self updateTOC].
	self changed: #outBoxStatus.
	^ id! !

!Celeste methodsFor: 'sending mail'!
replyTextFor: msgID
	"Answer the template for a reply to the message with the given ID."

	| msg s anyCCs replyaddress |
	msg _ mailDB getMessage: msgID.
	s _ WriteStream on: (String new: 500).

	"add From:"
	s nextPutAll: 'From: ', MailSender userName; cr.


	"add Subject:"
	((msg subject asLowercase indexOfSubCollection: 're:' startingAt: 1) ~= 0)
		ifTrue: [s nextPutAll: 'Subject: ', msg subject]
		ifFalse: [s nextPutAll: 'Subject: Re: ', msg subject].
	s cr.


	"add To:"
	"Use the Reply-To: address if there is one, otherwise the From: address"
	replyaddress _ msg from.
	msg headerFieldsNamed: 'reply-to' do: [ :destAdd | replyaddress _ destAdd ].
	s nextPutAll: 'To: ', replyaddress; cr.
	

	"add CC:s from the message and from the user's CC list"
	s nextPutAll: 'CC: '.
	anyCCs _ false.
	(msg to isEmpty) ifFalse: [
		anyCCs ifTrue:[ s nextPutAll: ', '] ifFalse: [ anyCCs _ true ].
		s nextPutAll: msg to ].
	(msg cc isEmpty) ifFalse: [
		anyCCs ifTrue: [ s nextPutAll: ', ' ] ifFalse: [ anyCCs _ true ].
		s nextPutAll: msg cc ].
	(Celeste ccList isEmpty) ifFalse: [
		anyCCs ifTrue: [ s nextPutAll: ', ' ] ifFalse: [ anyCCs _ true ].	
		s nextPutAll: Celeste ccList ].
	s cr.


	"add contents of previous message"
	s cr.
	s nextPutAll: msg from; nextPutAll: ' wrote:'; cr.
	msg bodyText linesDo: [ :line |
		s nextPutAll: '> '.
		s nextPutAll: line.
		s cr ].
	s cr.

	^s contents! !

!Celeste methodsFor: 'sending mail'!
sendMail: aCollectionOfMessages
	"Send <aCollectionOfMessages> to the SMTP server."

	| sender n message recipients socket |

	self requiredCategory: '.sent.'.

	self preSendAuthentication.

	sender _ (MailAddressParser addressesIn: MailSender userName) first.

	[socket _ SMTPSocket usingServer: MailSender smtpServer]
		ifError: [ :a :b | self error: 'error opening connection to mail server'].

	('sending ', aCollectionOfMessages size printString, ' messages...')
		displayProgressAt: Sensor mousePoint
		from: 1
		to: aCollectionOfMessages size
		during: [:progressBar |
			n _ 0.
			aCollectionOfMessages do: [:id |
				progressBar value: (n _ n + 1).
				message _ mailDB getMessage: id.

				recipients _ Set new.
				recipients addAll: (MailAddressParser addressesIn: message to).
				recipients addAll: (MailAddressParser addressesIn: message cc).

				[socket 
					mailFrom: sender
					to: recipients 
					text: message text.	"send this one message on the stream"

				mailDB remove: id fromCategory: '.tosend.'.
				mailDB file: id inCategory: '.sent.'
				] ifError: [ :a :b | self error: 'error posting mail']
		]].

	socket quit; close.
	mailDB saveDB.

	(self category = '.tosend.') |  (self category = '.sent.') ifTrue: [self updateTOC].

! !

!Celeste methodsFor: 'sending mail'!
sendQueuedMail
	"Post queued messages to the SMTP server."
	| outgoing sender n message recipients socket |
	mailDB ifNil: [ ^self ].
	outgoing _ mailDB messagesIn: '.tosend.'.
	outgoing isEmpty
		ifTrue: [^ self inform: 'no mail to be sent'].
	self requiredCategory: '.sent.'.
	self preSendAuthentication.
	sender _ (MailAddressParser addressesIn: MailSender userName) first.
	[socket _ SMTPSocket usingServer: MailSender smtpServer]
		ifError: [:a :b | self error: 'error opening connection to mail server'].
	'sending ' , outgoing size printString , ' messages...'
		displayProgressAt: Sensor mousePoint
		from: 1
		to: outgoing size
		during: [:progressBar | 
			n _ 0.
			outgoing
				do: [:id | 
					progressBar value: (n _ n + 1).
					message _ mailDB getMessage: id.
					recipients _ Set new.
					recipients
						addAll: (MailAddressParser addressesIn: message to).
					recipients
						addAll: (MailAddressParser addressesIn: message cc).
					[socket
						mailFrom: sender
						to: recipients
						text: message text.
					"send this one message on the stream"
					mailDB remove: id fromCategory: '.tosend.'.
					mailDB file: id inCategory: '.sent.']
						ifError: [:a :b | self error: 'error posting mail']]].
	socket quit; close.
	mailDB saveDB.
	self category = '.tosend.' | (self category = '.sent.')
		ifTrue: [self updateTOC].
	self changed: #outBoxStatus! !

!Celeste methodsFor: 'sending mail' stamp: 'dvf 5/17/2000 20:48'!
timeZoneString
	^Celeste userTimeZone! !

!Celeste methodsFor: 'initialize variables' stamp: 'sbw 1/28/2001 23:10'!
initializeTocLists
	tocLists _ Array new: 6.
	1
		to: tocLists size
		do: [:index | tocLists at: index put: OrderedCollection new]! !

!Celeste methodsFor: 'accessing' stamp: 'sbw 1/28/2001 22:36'!
tocLists
	"Generated - Return the value of tocLists."

	tocLists == nil ifTrue: [self initializeTocLists].
	^tocLists! !


!Celeste class methodsFor: 'class initialization' stamp: 'dvf 12/9/2002 19:22'!
initialize
	"Celeste initialize"
	"user preferences"
	CCList _ nil.
	DeleteInboxAfterFetching _ false.
	PopServer _ nil.
	PopUserName _ nil.
	SuppressWorthlessHeaderFields _ true.

	"options with no UI; just set their values directly"
	FormatWhenFetching _ false.

	"dictionary of custom filters"
	CustomFilters _ Dictionary new.

	MessageCountLimit _ 200.

	"Add global preferences"
	Preferences addPreferenceForOptionalCelesteStatusPane.
	Preferences addPreferenceForCelesteShowingAttachmentsFlag.
! !

!Celeste class methodsFor: 'class initialization' stamp: 'sw 11/11/2002 01:57'!
registerInOpenMenu
	"Register the receiver in the system's open menu"

	TheWorldMenu registerOpenCommand: 
		{ 'email reader' . { Celeste . #open }. '"Celeste", an e-mail client' }
	! !

!Celeste class methodsFor: 'class initialization' stamp: 'sw 11/11/2002 00:04'!
unload
	"Unload the receiver from global registries"

	TheWorldMenu unregisterOpenCommandWithReceiver: self! !

!Celeste class methodsFor: 'class initialization'!
versionString
	"Answer a short string describing this version of Celeste."

	| highestChangeSet versionAddendum |

	"the changeset number should probably be removed whenever Celeste settles down"
	highestChangeSet _ SystemVersion current highestUpdate.
	versionAddendum _ highestChangeSet
		ifNil: ['.x']
		ifNotNil: ['.' , highestChangeSet name initialIntegerOrNil printString].
	^ 'Celeste 2.0' , versionAddendum! !

!Celeste class methodsFor: 'instance creation' stamp: 'mdr 3/21/2001 17:33'!
current
	"Answer the currently active Celeste (assuming that there's
	only one Celeste open at a given time) or open a new one."

	Smalltalk garbageCollect.
	^Celeste allInstances detect: [:e | e isActive] ifNone: [self open].
! !

!Celeste class methodsFor: 'instance creation' stamp: 'ls 6/21/2001 17:55'!
defaultDBName
	"return the default database name to access"
	^'EMAIL'! !

!Celeste class methodsFor: 'instance creation' stamp: 'ls 6/21/2001 17:29'!
onDatabase: aMailDB
	"open a Celeste on the given MailDB"
	^super new openOnDatabase: aMailDB! !

!Celeste class methodsFor: 'instance creation' stamp: 'ls 6/21/2001 17:56'!
open
	"Open a MailReader on the default mail database."

	^ self openOn: self defaultDBName! !

!Celeste class methodsFor: 'instance creation' stamp: 'nk 8/8/2001 12:45'!
openOn: rootFilename
	"Open a MailReader on the mail database with the given root filename."
	|database |

	(MailDB isADBNamed: rootFilename)
		ifTrue: [ database _  MailDB openOn: rootFilename. ]
		ifFalse: [ database _ nil.  "open an empty Celeste with a welcome message" ].

	^self openOnDatabase: database! !

!Celeste class methodsFor: 'user preferences' stamp: 'ls 9/17/1998 05:46'!
ccList
	"Answer the default cc list to be used in composing messages."

	CCList isNil ifTrue: [CCList _ ''].
	^CCList! !

!Celeste class methodsFor: 'user preferences' stamp: 'ls 9/17/1998 05:51'!
popServer
	"Answer the server for downloading email via POP"

	(PopServer isNil or: [PopServer isEmpty])
		ifTrue: [self setPopServer].

	PopServer isEmpty ifTrue: [
		self error: 'POP server not specified' ].

	^PopServer! !

!Celeste class methodsFor: 'user preferences' stamp: 'ls 9/17/1998 05:51'!
popUserName
	"Answer the user's username on the POP server"

	(PopUserName isNil or: [PopUserName isEmpty])
		ifTrue: [self setPopUserName].

	PopUserName isEmpty ifTrue: [ 
		self error: 'no POP user name specified' ].

	^PopUserName! !

!Celeste class methodsFor: 'user preferences' stamp: 'ls 9/17/1998 05:46'!
setCCList
	"Change the list of names used in the default cc list. Items in the list should be valid mail addresses and should be separated by commas."

	| newList |
	(CCList isNil) ifTrue: [CCList _ ''].
	newList _ FillInTheBlank
		request: 'addresses to automatically add to CC: fields?'
		initialAnswer: CCList.
	CCList _ newList.! !

!Celeste class methodsFor: 'user preferences' stamp: 'ls 9/17/1998 05:48'!
setPopServer
	"Change the user's email name for use in composing messages."

	(PopServer isNil) ifTrue: [PopServer _ ''].
	PopServer _ FillInTheBlank
		request: 'What is your POP server''s hostname?'
		initialAnswer: PopServer.
! !

!Celeste class methodsFor: 'user preferences' stamp: 'ls 9/17/1998 05:48'!
setPopUserName
	"set the POP server used for downloading email"

	(PopUserName isNil) ifTrue: [PopUserName _ ''].
	PopUserName _ FillInTheBlank
		request: 'What is your username on your POP server?'
		initialAnswer: PopUserName.

	"be kind, if they include the host name here"
	(PopUserName includes: $@) ifTrue: [
		PopUserName _ PopUserName copyFrom: 1 to: (PopUserName indexOf: $@)-1 ].! !

!Celeste class methodsFor: 'user preferences' stamp: 'dvf 5/18/2000 00:08'!
setTimeZone
	TimeZone _ FillInTheBlank request: 'What is your time zone ?' initialAnswer: '+0300'! !

!Celeste class methodsFor: 'user preferences' stamp: 'sma 5/20/2000 10:18'!
userTimeZone
	"Answer the user's timezone string to be used when sending messages."

	TimeZone isEmptyOrNil ifTrue: [self setTimeZone].
	^ TimeZone ifNil: ['']! !

!Celeste class methodsFor: 'sending'!
eudoraSeparator
	"Return a Eudora-style message separator string."

	| s today dateString |
	s _ WriteStream on: (String new: 50).
	today _ Date today.
	dateString _ today printFormat: #(2 1 3 32 2 1).
	dateString _ dateString copyFrom: 1 to: dateString size - 4.
	s nextPutAll: 'From ???@??? '.
	s nextPutAll: (today weekday copyFrom: 1 to: 3); space.
	s nextPutAll: dateString.
	Time now print24: true on: s.
	s space.
	s print: today year; cr.
	^s contents
! !

!Celeste class methodsFor: 'options' stamp: 'sbw 1/28/2001 22:32'!
includeStatusPane

	^Preferences celesteHasStatusPane! !

!Celeste class methodsFor: 'options' stamp: 'sbw 2/5/2001 22:07'!
showAttachmentsFlag
	^ Preferences celesteShowsAttachmentsFlag! !

!Celeste class methodsFor: 'common build' stamp: 'sbw 1/28/2001 23:22'!
buildButtonFromSpec: spec forModel: model 
	| buttonViewClass b |
	Smalltalk isMorphic
		ifTrue: [buttonViewClass _ self morphicButtonsClass]
		ifFalse: [buttonViewClass _ PluggableButtonView].
	b _ buttonViewClass
				on: model
				getState: (self specificationFromList: spec at: 1)
				action: (self specificationFromList: spec at: 2).
	b
		label: (self specificationFromList: spec at: 3);
		 borderWidth: 1.
	b
		setBalloonText: (self specificationFromList: spec at: 4).
	^ b! !

!Celeste class methodsFor: 'common build' stamp: 'sbw 1/28/2001 23:22'!
buildButtonFromSpec: spec withBlock: aBlock 
	| b buttonViewClass |
	Smalltalk isMorphic
		ifTrue: [buttonViewClass _ self morphicButtonsClass]
		ifFalse: [buttonViewClass _ PluggableButtonView].
	b _ buttonViewClass new
				model: (Button new onAction: aBlock);
				
				action: (self specificationFromList: spec at: 1);
				
				label: (self specificationFromList: spec at: 2);
				 borderWidth: 1.
	b
		setBalloonText: (self specificationFromList: spec at: 3).
	^ b! !

!Celeste class methodsFor: 'common build' stamp: 'mdr 4/9/2001 21:55'!
buildButtonsFor: model 
	"Answer a collection of handy buttons for the Celeste user interface."
	| buttons b |
	buttons _ OrderedCollection new.
	b _ self buildButtonFromSpec: self specForSubjectFilterButton forModel: model.
	buttons add: b.
	b _ self buildButtonFromSpec: self specForParticipantFilterButton forModel: model.
	buttons add: b.
	b _ self buildButtonFromSpec: self specForCustomFilterButton forModel: model.
	buttons add: b.
	true
		ifFalse: ["Skip these buttons..."
	b _ self buildButtonFromSpec: self specForCustomFilterMoveButton forModel: model.
	buttons add: b].
	b _ self
				buildButtonFromSpec: self specForComposeButton
				withBlock: [model compose].
	buttons add: b.
	b _ self
				buildButtonFromSpec: self specForReplyButton
				withBlock: [model reply].
	buttons add: b.
	b _ self
				buildButtonFromSpec: self specForForwardButton
				withBlock: [model forward].
	buttons add: b.
	b _ self
				buildButtonFromSpec: self specForMoveAgainButton
				withBlock: [model moveAgain].
	buttons add: b.
	b _ self
				buildButtonFromSpec: self specForDeleteButton
				withBlock: [model deleteMessage].
	buttons add: b.
	^ buttons! !

!Celeste class methodsFor: 'common build' stamp: 'sw 6/25/2001 10:16'!
newOpenableMorph
	"Answer window for a MailReader on a blank database."

	^ (self buildTopMorphicWindowTitled: self defaultWindowTitle model: (self onDatabase: nil)) applyModelExtent! !

!Celeste class methodsFor: 'common build' stamp: 'ls 6/21/2001 17:29'!
openOnDatabase: aMailDB 
	"Open a MailReader on the given mail database."
	| model topWindow title |
	model _ self onDatabase: aMailDB.
	title _ self defaultWindowTitle.
	Smalltalk isMorphic
		ifTrue: [topWindow _ self
						buildTopMorphicWindowTitled: title
						model: model.
			topWindow openInWorld]
		ifFalse: [topWindow _ self buildTopMVCWindowTitled: title model: model.
			topWindow controller open].
	"in case the sender wants to know"
	^ model! !

!Celeste class methodsFor: 'common build' stamp: 'sbw 1/28/2001 23:23'!
specificationFromList: list at: index 
	| value |
	value _ list at: index.
	value = #nil
		ifTrue: [value _ nil].
	^ value! !

!Celeste class methodsFor: 'button specs' stamp: 'sbw 1/28/2001 23:19'!
specForComposeButton
	"action label helpText"
	^ #(#turnOn 'New' 'Compose a new message' )! !

!Celeste class methodsFor: 'button specs' stamp: 'sbw 1/30/2001 20:38'!
specForCustomFilterButton
	"getState action label helpText"
	^ #(#isCustomFilterOn #customFilterOn 'Custom F.' 'Select messages with a general custom filter' )! !

!Celeste class methodsFor: 'button specs' stamp: 'sbw 1/28/2001 23:20'!
specForCustomFilterMoveButton
	"getState action label helpText"
	^ #(#nil #customFilterMove 'Custom F. Move' 'Move messages which match a custom filter to appropriate category' )! !

!Celeste class methodsFor: 'button specs' stamp: 'sbw 1/28/2001 23:20'!
specForDeleteButton
	"action label helpText"
	^ #(#turnOn 'Delete' 'Delete the selected message' )! !

!Celeste class methodsFor: 'button specs' stamp: 'sbw 1/28/2001 23:20'!
specForForwardButton
	"action label helpText"
	^ #(#turnOn 'Forward' 'Forward the selected message' )! !

!Celeste class methodsFor: 'button specs' stamp: 'sbw 1/28/2001 23:20'!
specForMoveAgainButton
	"action label helpText"
	^ #(#turnOn 'Move Again' 'Move the selected message to the same category as previously' )! !

!Celeste class methodsFor: 'button specs' stamp: 'sbw 1/30/2001 20:40'!
specForParticipantFilterButton
	"getState action label helpText"
	^ #(#isParticipantFilterOn #participantFilterOn 'Part. F.' 'Select messages by their From:, To:, and Cc: lines' )! !

!Celeste class methodsFor: 'button specs' stamp: 'sbw 1/28/2001 23:20'!
specForReplyButton
	"action label helpText"
	^ #(#turnOn 'Reply' 'Reply to the selected message' )! !

!Celeste class methodsFor: 'button specs' stamp: 'sbw 1/30/2001 20:35'!
specForSubjectFilterButton
	"getState action label helpText"
	^ #(#isSubjectFilterOn #subjectFilterOn 'Subj. F.' 'Select messages by their subject' )! !

!Celeste class methodsFor: 'build-common' stamp: 'mdr 3/15/2001 14:46'!
defaultWindowTitle
	^ 'Celeste email browser'! !

!Celeste class methodsFor: 'build-mvc' stamp: 'sbw 1/30/2001 19:37'!
addMVCViews: views andButtons: buttons to: topWindow 
	(views at: 1)
		window: (0 @ 0 extent: 20 @ 25).
	(views at: 2)
		window: (0 @ 0 extent: 80 @ 25).
	(views at: 3)
		window: (0 @ 0 extent: 100 @ 70).
	(buttons at: 1)
		window: (0 @ 0 extent: 12 @ 5).
	(buttons at: 2)
		window: (0 @ 0 extent: 12 @ 5).
	(buttons at: 3)
		window: (0 @ 0 extent: 12 @ 5).
	(buttons at: 4)
		window: (0 @ 0 extent: 10 @ 5).
	(buttons at: 5)
		window: (0 @ 0 extent: 13 @ 5).
	(buttons at: 6)
		window: (0 @ 0 extent: 13 @ 5).
	(buttons at: 7)
		window: (0 @ 0 extent: 15 @ 5).
	(buttons at: 8)
		window: (0 @ 0 extent: 13 @ 5).
	topWindow
		addSubView: (buttons at: 1);
		
		addSubView: (buttons at: 2)
		toRightOf: (buttons at: 1);
		
		addSubView: (buttons at: 3)
		toRightOf: (buttons at: 2);
		
		addSubView: (buttons at: 4)
		toRightOf: (buttons at: 3);
		
		addSubView: (buttons at: 5)
		toRightOf: (buttons at: 4);
		
		addSubView: (buttons at: 6)
		toRightOf: (buttons at: 5);
		
		addSubView: (buttons at: 7)
		toRightOf: (buttons at: 6);
		
		addSubView: (buttons at: 8)
		toRightOf: (buttons at: 7);
		
		addSubView: (views at: 1)
		below: (buttons at: 1);
		
		addSubView: (views at: 2)
		toRightOf: (views at: 1);
		
		addSubView: (views at: 3)
		below: (views at: 1)! !

!Celeste class methodsFor: 'build-mvc' stamp: 'sbw 1/21/2001 22:02'!
buildTopMVCWindowTitled: title model: model 
	| topWindow views buttons |
	topWindow _ StandardSystemView new model: model;
				 label: title;
				 minimumSize: 400 @ 250.
	views _ self buildViewsFor: model.
	buttons _ self buildButtonsFor: model.
	self
		addMVCViews: views
		andButtons: buttons
		to: topWindow.
	^ topWindow! !

!Celeste class methodsFor: 'build-mvc' stamp: 'sbw 1/22/2001 00:09'!
buildViewsFor: model 
	"Answer a collection of window panes for the Celeste user interface."
	| listViewClass textViewClass listFont views v multiListViewClass |
	listViewClass _ PluggableListViewByItem.
	multiListViewClass _ PluggableListViewByItem.
	textViewClass _ PluggableTextView.
	listFont _ StrikeFont allSubInstances
				detect: [:f | (f name beginsWith: 'CourierFixed')
						and: [f height = 11]]
				ifNone: [TextStyle defaultFont].
	views _ OrderedCollection new.
	v _ listViewClass
				on: model
				list: #categoryList
				selected: #category
				changeSelected: #setCategory:
				menu: #categoryMenu:
				keystroke: #categoriesKeystroke:.
	views add: v.
	v _ multiListViewClass
				on: model
				list: #tocEntryList
				selected: #tocEntry
				changeSelected: #setTOCEntry:
				menu: #tocMenu:
				keystroke: #tocKeystroke:.
	v font: listFont.
	views add: v.
	v _ textViewClass new
				on: model
				text: #messageText
				accept: #messageText:
				readSelection: nil
				menu: #messageMenu:shifted:.
	v borderWidth: 1.
	model messageTextView: v.
	views add: v.
	v _ textViewClass new
				on: model
				text: #status
				accept: nil
				readSelection: nil
				menu: nil.
	v borderWidth: 1.
	model messageTextView: v.
	views add: v.
	^ views! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 1/30/2001 20:04'!
addLowerMorphicViews: views andButtons: buttons to: topWindow offset: offset 
	| row verticalOffset innerFractions |
	row _ AlignmentMorph newColumn hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 layoutInset: 0;
				 borderWidth: 1;
				 borderColor: Color black;
				 layoutPolicy: ProportionalLayout new.
	verticalOffset _ 0.
	innerFractions _ 0 @ 0 corner: 1 @ 0.
	verticalOffset _ self
				addMorphicButtons: buttons
				to: row
				at: innerFractions
				plus: verticalOffset.
	self includeStatusPane ifTrue: [
	verticalOffset _ self
				addMorphicStatusPaneTo: row
				from: views
				at: innerFractions
				plus: verticalOffset].
	self
		addMorphicTextPaneTo: row
		from: views
		at: innerFractions
		plus: verticalOffset.
	topWindow
		addMorph: row
		frame: (0 @ offset extent: 1 @ (1 - offset)).
	row
		on: #mouseEnter
		send: #paneTransition:
		to: topWindow.
	row
		on: #mouseLeave
		send: #paneTransition:
		to: topWindow! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 1/22/2001 20:53'!
addMorphicButtons: buttons to: row at: innerFractions plus: verticalOffset 
	| delta buttonRow |
	delta _ 25.
	buttonRow _ self morphicButtonRowFrom: buttons.
	buttonRow 
				color: (Color gray alpha: 0.2);
				 borderWidth: 1;
				 borderColor: Color lightGray.
	row addMorph: buttonRow
				fullFrame: (LayoutFrame
						fractions: innerFractions
						offsets: (0@verticalOffset corner: 0@(verticalOffset + delta))).
	^ verticalOffset + delta! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 2/3/2001 08:18'!
addMorphicStatusPaneTo: row from: views at: innerFractions plus: verticalOffset 
	| delta statusFractions outputBoxFractions |
	delta _ 20.
	statusFractions _ innerFractions withRight: 0.5.
	outputBoxFractions _ (statusFractions withLeft: 0.5)
				withRight: 1.
	row
		addMorph: (views at: #status)
		fullFrame: (LayoutFrame
				fractions: statusFractions
				offsets: (0 @ verticalOffset corner: 0 @ (verticalOffset + delta))).
	row
		addMorph: (views at: #outBoxStatus)
		fullFrame: (LayoutFrame
				fractions: outputBoxFractions
				offsets: (0 @ verticalOffset corner: 0 @ (verticalOffset + delta))).
	^ verticalOffset + delta! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 1/22/2001 20:43'!
addMorphicTextPaneTo: row from: views at: innerFractions plus: verticalOffset 
	row
		addMorph: (views at: #messageText)
		fullFrame: (LayoutFrame
				fractions: (innerFractions withBottom: 1)
				offsets: (0 @ verticalOffset corner: 0@0)).
	^ verticalOffset

! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 1/22/2001 20:22'!
addMorphicViews: views andButtons: buttons to: topWindow 
	topWindow
		addMorph: (views at: #categoryList)
		frame: (0.0 @ 0.0 extent: 0.2 @ 0.25).
	topWindow
		addMorph: (views at: #tocEntryList)
		frame: (0.2 @ 0.0 extent: 0.8 @ 0.25).
	self
		addLowerMorphicViews: views
		andButtons: buttons
		to: topWindow
		offset: 0.25 ! !

!Celeste class methodsFor: 'build-morphic' stamp: 'mdr 4/6/2001 21:25'!
buildMorphicCategoryListFor: model
	^(PluggableListMorphByItem
				on: model
				list: #categoryList
				selected: #category
				changeSelected: #setCategory:
				menu: #categoryMenu:
				keystroke: #categoriesKeystroke:) enableDragNDrop: true.! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 1/21/2001 22:19'!
buildMorphicMessageTextPaneFor: model 
	^ PluggableTextMorph new
				on: model
				text: #messageText
				accept: #messageText:
				readSelection: nil
				menu: #messageMenu:shifted:! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 2/3/2001 08:18'!
buildMorphicOutBoxStatusPaneFor: model 
	^ PluggableTextMorph new
		on: model
		text: #outBoxStatus
		accept: nil
		readSelection: nil
		menu: nil! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 1/21/2001 22:20'!
buildMorphicStatusPaneFor: model 
	^ PluggableTextMorph new
				on: model
				text: #status
				accept: nil
				readSelection: nil
				menu: nil.! !

!Celeste class methodsFor: 'build-morphic' stamp: 'mdr 4/6/2001 12:36'!
buildMorphicTocEntryListFor: model 
	^ (PluggableMultiColumnListMorphByItem
				on: model
				list: #tocEntryList
				selected: #tocEntry
				changeSelected: #setTOCEntry:
				menu: #tocMenu:
				keystroke: #tocKeystroke:
) enableDragNDrop: true.! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 2/3/2001 08:18'!
buildMorphicViewsFor: model 
	"Answer a dictionary of window panes for the Celeste user interface."
	| listFont views v |
	listFont _ StrikeFont allSubInstances
				detect: [:f | (f name beginsWith: 'CourierFixed')
						and: [f height = 11]]
				ifNone: [TextStyle defaultFont].
	views _ Dictionary new.
	v _ self buildMorphicCategoryListFor: model.
	views at: #categoryList put: v.
	v _ self buildMorphicTocEntryListFor: model.
	v font: listFont.
	views at: #tocEntryList put: v.
	v _ self buildMorphicMessageTextPaneFor: model.
	v borderWidth: 1.
	model messageTextView: v.
	views at: #messageText put: v.
	v _ self buildMorphicStatusPaneFor: model.
	v borderWidth: 1.
	views at: #status put: v.
	v _ self buildMorphicOutBoxStatusPaneFor: model.
	v borderWidth: 1.
	views at: #outBoxStatus put: v.
	^ views! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 1/22/2001 00:50'!
buildTopMorphicWindowTitled: title model: model 
	| topWindow views buttons |
	topWindow _ (SystemWindow labelled: title)
				model: model.
	buttons _ self buildButtonsFor: model.
	views _ self buildMorphicViewsFor: model.
	self addMorphicViews: views andButtons: buttons to: topWindow .
	buttons
		do: [:b | b onColor: Color lightGray offColor: Color white].
	^ topWindow! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 2/2/2001 13:01'!
morphicButtonRowFrom: buttons 
	| aRow |
	aRow _ AlignmentMorph newRow.
	aRow setNameTo: 'buttonPane'.
	aRow beSticky.
	aRow hResizing: #spaceFill.
	aRow wrapCentering: #center;
		 cellPositioning: #leftCenter.
	aRow clipSubmorphs: true.
	aRow addTransparentSpacerOfSize: 5 @ 0.
	buttons
		do: [:btn | 
			btn useRoundedCorners;
			 hResizing: #spaceFill;
						 vResizing: #spaceFill.
			aRow addMorphBack: btn.
			aRow addTransparentSpacerOfSize: 3 @ 0].
	^ aRow! !

!Celeste class methodsFor: 'build-morphic' stamp: 'sbw 1/21/2001 20:55'!
morphicButtonsClass

	^PluggableButtonMorph! !

!Celeste class methodsFor: 'accessing' stamp: 'mdr 3/15/2001 15:41'!
messageCountLimit

	^ MessageCountLimit! !

!Celeste class methodsFor: 'accessing' stamp: 'sbw 1/30/2001 20:09'!
messageCountLimit: anInteger
	MessageCountLimit _ anInteger! !

!Celeste class methodsFor: 'filters' stamp: 'ls 2/10/2001 10:15'!
makeFilterFor: filterExpr
	"compile a given custom filter"
	^Compiler evaluate: '[ :m | ', filterExpr, ']'.

! !


!CelesteComposition methodsFor: 'access' stamp: 'dvf 5/11/2002 00:22'!
submit
	| message msgID |
	"submit the message"
	textEditor
		ifNotNil: [self hasUnacceptedEdits ifTrue: [textEditor accept]].
	message := MailMessage from: messageText asString.
	self breakLinesInMessage: message.
	msgID _ (celeste isActive ifTrue: [celeste] ifFalse: [Celeste current])
				queueMessageWithText: message text.
	msgID ifNil: [^self].		"There was an error, so do not close"

	morphicWindow ifNotNil: [morphicWindow delete].
	mvcWindow ifNotNil: [mvcWindow controller close]
! !

!CelesteComposition methodsFor: 'initialization' stamp: 'dvf 5/11/2002 01:21'!
celeste: aCeleste  initialText: aText
	celeste _ aCeleste.
	messageText _ aText.! !


!CelesteComposition class methodsFor: 'instance creation' stamp: 'dvf 5/11/2002 01:21'!
celeste: aCeleste  initialText: initialText
	"create an instance for the given mail reader, editting the given text"
	^self new celeste: aCeleste  initialText: initialText! !

!CelesteComposition class methodsFor: 'instance creation' stamp: 'dvf 5/11/2002 01:22'!
openForCeleste: aCeleste  initialText: initialText
	"open a composition window for the given mail reader, editting the given text"
	(self celeste: aCeleste  initialText: initialText) open! !

!CelesteComposition class methodsFor: 'as yet unclassified' stamp: 'dvf 5/17/2002 16:01'!
initialize
	super initialize.
	MailSender registerMailSender: self.! !

!CelesteComposition class methodsFor: 'as yet unclassified' stamp: 'dvf 5/11/2002 01:25'!
sendMailMessage: aMailMessage
	self openForCeleste: Celeste current initialText: aMailMessage text! !

!CelesteComposition class methodsFor: 'as yet unclassified' stamp: 'dvf 5/17/2002 16:01'!
unload

	MailSender unregisterMailSender: self ! !


!CelesteTestCase methodsFor: 'running' stamp: 'ls 6/21/2001 17:48'!
testGraceWithoutMailDB
	"test that a celeste without a mailDB loaded will gracefully accept all UI messages and do nothing"
	| dbLessCeleste menu |
	dbLessCeleste := Celeste onDatabase: nil.

	"try pressing all the buttons"
	(Celeste buildButtonsFor: dbLessCeleste) do: [ :button |
		button performAction.
		button performAction. ].


	"try all the table-of-contents menu items"
	menu := MenuMorph new defaultTarget: dbLessCeleste.
	dbLessCeleste tocMenu: menu.
	menu items do: [ :menuItem | menuItem doButtonAction ].

	"try all the category menu items"
	menu := MenuMorph new defaultTarget: dbLessCeleste.
	dbLessCeleste categoryMenu: menu.
	menu items do: [ :menuItem | menuItem doButtonAction ].! !


!Flaps class methodsFor: 'predefined flaps' stamp: 'sw 1/29/2002 16:52'!
quadsDefiningToolsFlap
	"Answer a structure defining the default Tools flap"

	^ #(
	(Browser 				prototypicalToolWindow		'Browser'			'A Browser is a tool that allows you to view all the code of all the classes in the system')
	(TranscriptStream				openMorphicTranscript				'Transcript'			'A Transcript is a window usable for logging and debugging; browse references to #Transcript for examples of how to write to it.')
	(Workspace				prototypicalToolWindow		'Workspace'			'A Workspace is a simple window for editing text.  You can later save the contents to a file if you desire.')
	(FileList					prototypicalToolWindow		'File List'			'A File List is a tool for browsing folders and files on disks and on ftp types.')
	(DualChangeSorter		prototypicalToolWindow		'Change Sorter'		'Shows two change sets side by side')
	(SelectorBrowser			prototypicalToolWindow		'Method Finder'		'A tool for discovering methods by providing sample values for arguments and results')
	(MessageNames			prototypicalToolWindow		'Message Names'		'A tool for finding, viewing, and editing all methods whose names contain a given character sequence.')
	(Preferences			preferencesControlPanel	'Preferences'			'Allows you to control numerous options')
	(Utilities				recentSubmissionsWindow	'Recent'				'A message browser that tracks the most recently-submitted methods')
	(ProcessBrowser			prototypicalToolWindow		'Processes'			'A Process Browser shows you all the running processes')
	(Preferences			annotationEditingWindow	'Annotations'		'Allows you to specify the annotations to be shown in the annotation panes of browsers, etc.')
	(Scamper				newOpenableMorph			'Scamper'			'A web browser')
	(Celeste					newOpenableMorph			'Celeste'				'Celeste -- an EMail reader')
	(PackagePaneBrowser	prototypicalToolWindow		'Packages'			'Package Browser:  like a System Browser, except that if has extra level of categorization in the top-left pane, such that class-categories are further organized into groups called "packages"')
	(ChangeSorter			prototypicalToolWindow		'Change Set'			'A tool that allows you to view and manipulate all the code changes in a single change set')

)! !


!IndexFileEntry methodsFor: 'access'!
cc

	^cc! !

!IndexFileEntry methodsFor: 'access'!
cc: aString

	cc _ aString.! !

!IndexFileEntry methodsFor: 'access'!
date
	"Answer a date string for this index entry."

	^Date fromDays: (time + (Date newDay: 1 year: 1980) asSeconds) // 86400! !

!IndexFileEntry methodsFor: 'access'!
from

	^from! !

!IndexFileEntry methodsFor: 'access'!
from: aString

	from _ aString.! !

!IndexFileEntry methodsFor: 'access' stamp: 'dvf 5/13/2000 00:51'!
likelyEqual: otherIndexFileEntry
	"return true if the two toc entries seem to represent the same message"
	^(self textLength = otherIndexFileEntry textLength and: [self subject = otherIndexFileEntry subject]) and: [self from = otherIndexFileEntry from]! !

!IndexFileEntry methodsFor: 'access'!
location

	^location! !

!IndexFileEntry methodsFor: 'access'!
location: anInteger

	location _ anInteger.! !

!IndexFileEntry methodsFor: 'access'!
messageFile

	^messageFile! !

!IndexFileEntry methodsFor: 'access'!
messageFile: aMessageFile

	messageFile _ aMessageFile.! !

!IndexFileEntry methodsFor: 'access'!
msgID

	^msgID! !

!IndexFileEntry methodsFor: 'access'!
msgID: anID

	msgID _ anID.! !

!IndexFileEntry methodsFor: 'access'!
subject

	^subject! !

!IndexFileEntry methodsFor: 'access'!
subject: aString

	subject _ aString.! !

!IndexFileEntry methodsFor: 'access'!
textLength

	^textLength! !

!IndexFileEntry methodsFor: 'access'!
textLength: anInteger

	textLength _ anInteger.! !

!IndexFileEntry methodsFor: 'access'!
time

	^time! !

!IndexFileEntry methodsFor: 'access'!
time: anInteger

	time _ anInteger.! !

!IndexFileEntry methodsFor: 'access'!
to

	^to! !

!IndexFileEntry methodsFor: 'access'!
to: aString

	to _ aString.! !

!IndexFileEntry methodsFor: 'printing' stamp: 'bf 3/9/2000 16:09'!
computeTOCString
	"Answer a string for the table of contents."
	"IndexFileEntry allInstancesDo: [: e | e flushTOCCache]"

	| fromFieldSize s |
	fromFieldSize _ 18.
	s _ WriteStream on: (String new: 200).
	s nextPutAll: self dateString.
	[s position < 9] whileTrue: [s space].
	s nextPutAll: (self fromStringLimit: fromFieldSize).
	[s position <= (9 + fromFieldSize + 2)] whileTrue: [s space].
	s nextPutAll: subject decodeMimeHeader.
	^ s contents
! !

!IndexFileEntry methodsFor: 'printing' stamp: 'sbw 2/5/2001 21:59'!
computeTOCStringAsColumns
	"Answer a string for the table of contents."
	"IndexFileEntry allInstancesDo: [: e | e flushTOCCache]"
	| fromFieldSize array attachFlag |
	fromFieldSize _ 18.
	attachFlag _ Celeste showAttachmentsFlag
		ifTrue: [self getMessage body isMultipart]
		ifFalse: [false].
	array _ Array new: 5.
	array at: 1 put: self dateString.
	array
		at: 2
		put: (self fromStringLimit: fromFieldSize).
	array at: 3 put: subject decodeMimeHeader.
	array at: 4 put: self textLength asStringWithCommas.
	array at: 5 put: attachFlag.
	^ array! !

!IndexFileEntry methodsFor: 'printing'!
dateString
	"Answer a date string for this index entry."

	^self date printFormat: #(2 1 3 47 1 2)! !

!IndexFileEntry methodsFor: 'printing'!
flushTOCCache
	"Flush my cached table-of-contents entry string."
	"IndexFileEntry allInstancesDo: [: e | e flushTOCCache]"

	tocLineCache _ nil.! !

!IndexFileEntry methodsFor: 'printing' stamp: 'bf 3/9/2000 16:05'!
fromStringLimit: limit
	"Answer a cleaned up 'from' field for the table of contents."

	| editedFrom s ch i |
	editedFrom _ WriteStream on: (String new: limit + 1).
	s _ ReadStream on: from decodeMimeHeader.
	s skipSeparators.
	('"<' includes: s peek) ifTrue: [s next].
	((i _ from indexOf: $() > 0) ifTrue: [s position: i].
	[s atEnd] whileFalse: [
		ch _ s next.
		(('@<>)$"' includes: ch) or: [editedFrom position >= limit])
			ifTrue: [^editedFrom contents]
			ifFalse: [editedFrom nextPut: ch]].
	^editedFrom contents
! !

!IndexFileEntry methodsFor: 'printing'!
printOn: aStream

	aStream nextPutAll: self dateString; cr.
	aStream nextPutAll: from; cr.
	aStream nextPutAll: to; cr.
	aStream nextPutAll: cc; cr.
	aStream nextPutAll: subject; cr.
	aStream nextPut: $(; nextPutAll: location printString; space.
	aStream nextPutAll: textLength printString; nextPut: $).
	aStream cr.! !

!IndexFileEntry methodsFor: 'printing'!
tocString
	"Answer a string for the table of contents."

	(tocLineCache isNil) ifTrue:
		[tocLineCache _ self computeTOCString].
	^tocLineCache! !

!IndexFileEntry methodsFor: 'printing' stamp: 'sbw 12/25/2000 20:47'!
tocStringAsColumns
	"Answer a string for the table of contents."
	^self computeTOCStringAsColumns! !

!IndexFileEntry methodsFor: 'read-write'!
readFrom: aStream
	"Initialize myself from the given text stream."

	location _ MailDB readIntegerLineFrom: aStream.
	textLength _ MailDB readIntegerLineFrom: aStream.
	time _ MailDB readIntegerLineFrom: aStream.
	from _ MailDB readStringLineFrom: aStream.
	to _ MailDB readStringLineFrom: aStream.
	cc _ MailDB readStringLineFrom: aStream.
	subject _ MailDB readStringLineFrom: aStream.! !

!IndexFileEntry methodsFor: 'read-write' stamp: 'ls 10/6/1998 13:22'!
writeOn: aStream
	"Write a human-readable representation of myself on the given text stream."

	aStream
		nextPutAll: location printString; cr;
		nextPutAll: textLength printString; cr;
		nextPutAll: time printString; cr;
		nextPutAll: from; cr;
		nextPutAll: to; cr;
		nextPutAll: cc; cr;
		nextPutAll: subject; cr.
! !

!IndexFileEntry methodsFor: 'filtering support'!
ccHas: stringOrList

	^ self field: cc has: stringOrList! !

!IndexFileEntry methodsFor: 'filtering support' stamp: 'jm 8/14/1998 13:39'!
field: field has: stringOrList
	"Return true if either the given field contains the argument string or, if the argument is a collection, return true if the given field contains any of the strings in that collection."

	| s |
	(stringOrList isKindOf: String) ifTrue: [
		^ field includesSubstring: stringOrList caseSensitive: false
	] ifFalse: [
		1 to: stringOrList size do: [ :i |
			s _ stringOrList at: i.
			s isNumber ifTrue: [s _ s printString].
			(field includesSubstring: s caseSensitive: false) ifTrue: [^ true].
		].
		^ false
	].! !

!IndexFileEntry methodsFor: 'filtering support'!
fromHas: stringOrList

	^ self field: from has: stringOrList! !

!IndexFileEntry methodsFor: 'filtering support' stamp: 'dvf 5/13/2000 02:25'!
getMessage
	"Answer the MailMessage for this index file entry."
	^ MailMessage from: (self rawText)! !

!IndexFileEntry methodsFor: 'filtering support'!
participantHas: stringOrList

	^ (self field: from has: stringOrList) or:
	   [(self field: self to has: stringOrList) or:
	   [self field: self cc has: stringOrList]]! !

!IndexFileEntry methodsFor: 'filtering support' stamp: 'dvf 5/13/2000 02:25'!
rawText
	"Answer the unparsed text for this entry."
	^ messageFile
			getMessage: msgID
			at: location
			textLength: textLength! !

!IndexFileEntry methodsFor: 'filtering support'!
subjectHas: stringOrList

	^ self field: subject has: stringOrList! !

!IndexFileEntry methodsFor: 'filtering support' stamp: 'dvf 5/13/2000 02:11'!
text
	^self getMessage text! !

!IndexFileEntry methodsFor: 'filtering support' stamp: 'dvf 5/13/2000 02:11'!
textHas: stringOrList 
	^ self field: self text has: stringOrList! !

!IndexFileEntry methodsFor: 'filtering support'!
toHas: stringOrList

	^ self field: to has: stringOrList! !

!IndexFileEntry methodsFor: 'testing' stamp: 'mdr 4/12/2001 12:20'!
comparableString: aString
	"This is for Celeste testing purposes only"

	"Return exactly this string.  This is the most strict mode, meaning things must be exactly equal"
	^ aString  

	"Make consecutive white space into a single space (less strict but still pretty)"
	"^ (aString collect: [ :ch | ch isSeparator ifTrue: [ Character space ] ifFalse: [ ch ] ])
			withBlanksCondensed"

	"Look only at nonwhite characters (least strict)"
	"^ aString select: [ :ch | ch isSeparator not ]"	



	"(self comparableString: 'a  b	c')  = (self comparableString: 'a	b     c')"
! !

!IndexFileEntry methodsFor: 'testing' stamp: 'mdr 4/12/2001 14:57'!
selfTestEquals: anIndexFileEntry
	"For testing and debugging purposes only, test whether the two entries are equivalent.  If you expect that IndexFileEntries should be identical, the use strict equality here.  Otherwise use approximate comparisons."

	"These should be exactly equal"
	#(messageFile msgID location from) do:
		[ :sel | ((self perform: sel) = (anIndexFileEntry perform: sel)) ifFalse: [ 
			Transcript cr.
			Transcript show: msgID printString, ' ', sel printString, ': ', (self perform: sel); cr.
			Transcript show: msgID printString, 'n', sel printString, ': ', (anIndexFileEntry perform: sel); cr.
]].

	"These should be comparably equal :-), typically varying only by white space"
	#(cc to subject) do:
		[ :sel | ((self comparableString: (self perform: sel)) =
				(self comparableString: (anIndexFileEntry perform: sel))) ifFalse: [
			Transcript cr.
			Transcript show: msgID printString, ' ', sel printString, ': ', (self perform: sel); cr.
			Transcript show: msgID printString, 'n', sel printString, ': ', (anIndexFileEntry perform: sel); cr.
]].

	"It could be that these are not absolutely identical, though they should be close"
	#(date time) do:
		[ :sel | (self perform: sel) = (anIndexFileEntry perform: sel) ifFalse:
					[Transcript cr;
						show: msgID printString, ' ', sel printString, ':', (self perform: sel) printString; cr]].

	[(self textLength - anIndexFileEntry textLength) abs <= 2] assert. 
! !


!IndexFileEntry class methodsFor: 'instance creation'!
message: aMailMessage location: location messageFile: aMessageFile msgID: msgID
	"Answer a new instance of me for the given message and message file location."

	^self new
		messageFile: aMessageFile;
		msgID: msgID;
		location: location;
		textLength: aMailMessage text size;
		time: aMailMessage time;
		from: aMailMessage from;
		to: aMailMessage to;
		cc: aMailMessage cc;
		subject: aMailMessage subject! !

!IndexFileEntry class methodsFor: 'instance creation'!
readFrom: aStream messageFile: aMessageFile msgID: msgID
	"Answer a new instance of me initialized from the given text stream."

	^(self new readFrom: aStream)
		messageFile: aMessageFile;
		msgID: msgID! !


!MailDB methodsFor: 'initialize-release' stamp: 'mdr 3/20/2001 19:16'!
close
	"Close up the database in preparation for closing celeste"

	self saveDB.
	indexFile ifNotNil: [indexFile save].
	messageFile ifNotNil: [messageFile close].

	rootFilename _ nil.
	messageFile _ indexFile _ categoriesFile _ nil.! !

!MailDB methodsFor: 'initialize-release'!
openOn: rootNameString
	"Open a mail database with the given root file name."

	| status |
	rootFilename _ rootNameString.
	status _ self dbStatus.
	messageFile _ indexFile _ categoriesFile _ nil.
	(status = #exists) ifTrue: [^self openDB].
	(status = #partialDatabase) ifTrue: [^self recoverDB].
	(status = #doesNotExist) ifTrue: [^self createDB].! !

!MailDB methodsFor: 'open-create-save' stamp: 'ls 6/21/2001 00:11'!
createDB
	"Create a new mail database."


	self openDB.							"creates new DB files"
	self saveDB.							"save the new mail database to disk"! !

!MailDB methodsFor: 'open-create-save' stamp: 'ls 6/21/2001 00:05'!
dbStatus
	^self class dbStatusFor: rootFilename! !

!MailDB methodsFor: 'open-create-save' stamp: 'sr 2/19/2001 06:49'!
openDB
	"Open an existing mail database."

	Transcript show: 'Opening mail database ''', rootFilename, '''...'.
	messageFile _ MessageFile openOn: rootFilename, '.messages'.
	indexFile _ IndexFile openOn: rootFilename, '.index' messageFile: messageFile readLogFlag: true.
	categoriesFile _ CategoriesFile openOn: rootFilename, '.categories'.
	Transcript show: 'Done.'; cr.! !

!MailDB methodsFor: 'open-create-save' stamp: 'mdr 3/21/2001 17:10'!
recoverDB
	"Open a mail database with the given root file name."

	(self confirm:
'The mail database named:
    ', rootFilename, '
appears to be damaged.
Shall I fix it?  (This might take some time)')
		ifFalse: [self release. ^nil].

	self openDB.
	Cursor execute showWhile: [self compact].! !

!MailDB methodsFor: 'open-create-save'!
rootFilename
	"Answer my root filename."

	^rootFilename! !

!MailDB methodsFor: 'open-create-save' stamp: 'mdr 3/23/2001 13:59'!
saveDB
	"Write all database files to disk."

	"Return quietly if the database is no longer in use"
	rootFilename isNil & messageFile isNil & indexFile isNil & categoriesFile isNil
		ifTrue: [^self].

	Transcript show: 'Saving mail database ''' , (rootFilename ifNil: ['']) , '''...'.

	messageFile notNil ifTrue: [messageFile save].
	"indexFile notNil ifTrue: [indexFile save].    Omitted because of incremental log file saving"
	categoriesFile notNil ifTrue: [categoriesFile save].

	Transcript show: 'Done.'; cr! !

!MailDB methodsFor: 'fetch-import-export' stamp: 'jm 10/14/1998 12:31'!
fetchMailFromPOP: server userName: userName password: password doFormatting: doFormatting deleteFromServer: deleteFromServer
	"Download mail from the given POP3 mail server and append it this mail database. Answer the number of messages fetched. If doFormatting is true, messages will be formatted as they are received. If deleteFromServer is true, then messages will be removed from the POP3 server after being successfully retrieved. (Note: If there is a failure while fetching mail, all messages will be left on the server.)"

	| popConnection msgCount |
	Socket initializeNetwork.
	popConnection _ POPSocket new
		serverName: server;	
		userName: userName;
		password: password;
		addProgressObserver: Transcript.
	Utilities
		informUser: 'connecting to ', server
		during: [popConnection connectToPOP].
	popConnection isConnected ifFalse: [^ -1].

	msgCount _ popConnection numMessages.
	msgCount > 0 ifTrue: [
		self fetchMessageCount: msgCount
			fromPOPConnection: popConnection
			doFormatting: doFormatting.

		deleteFromServer ifTrue: [
			self removeMessageCount: msgCount fromPOPConnection: popConnection]].

	popConnection disconnectFromPOP.
	^ msgCount
! !

!MailDB methodsFor: 'fetch-import-export' stamp: 'mdr 3/22/2001 17:55'!
fetchMessageCount: msgCount fromPOPConnection: popConnection doFormatting: doFormatting
	"Download the given number of messages from the given open POP3 connection. If doFormatting is true, messages will be formatted as they are received."

	| nextID msgText msg location |
	messageFile beginAppend.
	('Downloading ', msgCount printString, ' messages...')
		displayProgressAt: Sensor mousePoint
		from: 0
		to: msgCount
		during: [:progressBar |
			1 to: msgCount do: [:messageNum |
				progressBar value: messageNum.
				popConnection isConnected ifFalse: [
					popConnection destroy.  "network error"
					messageFile endAppend.
					self saveDB.
					^ self inform: 'Server connection unexpectedly closed.'].

				"get a message"
				msgText _ popConnection retrieveMessage: messageNum.
				nextID _ self nextUnusedID.

				"save that message"
				msg _ MailMessage from: msgText.
				doFormatting ifTrue: [msg format].
				location _ messageFile basicAppend: msg text id: nextID.
				indexFile
					at: nextID
					put: (IndexFileEntry
						message: msg
						location: location
						messageFile: messageFile
						msgID: nextID).
				categoriesFile file: nextID inCategory: 'new'.
				]].

	messageFile endAppend.
	self saveDB.
! !

!MailDB methodsFor: 'fetch-import-export' stamp: 'mdr 3/22/2001 18:08'!
fetchNewsFrom: inboxPathName doFormatting: doFormatting deleteInbox: deleteInbox
	"Append the messages from the given news inbox file to this mail database. Answer the number of messages fetched."

	| inbox nextID count msg location |
	"is there any news?"
	((FileDirectory on: inboxPathName) includesKey: 'news') ifFalse: [^ 0].

	inbox _ RNInboxFile openOn: inboxPathName, ':news'.
	count _ 0.
	messageFile beginAppend.
	inbox newsMessagesDo:
		[: newsgroup : msgText |
		 msg _ MailMessage from: msgText.
		 nextID _ self nextUnusedID.
		 doFormatting ifTrue: [msg format].
		 location _ messageFile basicAppend: msg text id: nextID.
		 indexFile
			at: nextID
			put: (IndexFileEntry
					message: msg
					location: location
					messageFile: messageFile
					msgID: nextID).
		 categoriesFile file: nextID inCategory: newsgroup.
		 categoriesFile file: nextID inCategory: 'new'.
		 count _ count + 1].
	messageFile endAppend.

	"snapshot the database and remove the inbox file"
	self saveDB.
	deleteInbox ifTrue: [inbox delete].
	^ count
! !

!MailDB methodsFor: 'fetch-import-export' stamp: 'mdr 3/22/2001 18:09'!
importMailFrom: inboxFileName intoCategory: category
	"Append the messages from the given mail file to this mail database, and store them in the given category. Answer the number of messages imported."

	| inbox nextID count msg location |
	inbox _ MailInboxFile openOn: inboxFileName.
	count _ 0.
	messageFile beginAppend.
	inbox mailMessagesDo: [:msgText |
		 msg _ MailMessage from: msgText.
		 nextID _ self nextUnusedID.
		 location _ messageFile basicAppend: msg text id: nextID.
		 indexFile
			at: nextID
			put: (IndexFileEntry
					message: msg
					location: location
					messageFile: messageFile
					msgID: nextID).
		 categoriesFile file: nextID inCategory: category.
		 count _ count + 1].
	messageFile endAppend.
	self saveDB.
	^ count
! !

!MailDB methodsFor: 'fetch-import-export'!
mergeMessages: msgIDList from: sourceDB
	"Merge the given collection of messages from the source database into the receiver. When a message being added has the same message ID as an existing message, check to see if the two message texts are identical. If so, do not store the duplicate message. If the texts are different, make a new ID for the message being added. This operation will also copy the category information from the sourceDB, creating new catetories if necessary."

	| msgText newMsgID saveIt msg location entry |
	messageFile beginAppend.
	msgIDList do:
		[: oldMsgID |
		 msgText _ sourceDB getText: oldMsgID.

		 "resolve ID conflicts"
		 (indexFile includesKey: oldMsgID)
			ifFalse:	"no ID conflict"
				[newMsgID _ oldMsgID.
				 saveIt _ true]
			ifTrue:	"resolve an ID conflict"
				[(msgText = (self getText: oldMsgID))
					ifTrue:	"identical text; don't save again"
						[newMsgID _ oldMsgID.
						 saveIt _ false]
					ifFalse:	"different text; save with new ID"
						[newMsgID _ self nextUnusedID.
						 saveIt _ true]].

		 "save the message in the destination DB"
		 saveIt ifTrue:
			[msg _ MailMessage from: msgText.
			 location _ messageFile basicAppend: msg text id: newMsgID.
			 entry _ IndexFileEntry
						message: msg
						location: location 
						messageFile: messageFile
						msgID: newMsgID.
			 indexFile at: newMsgID put: entry].

		 "update the categories for the message in the destination DB"
		 (sourceDB categoriesThatInclude: oldMsgID) do:
			[: categoryName |
			 self file: newMsgID inCategory: categoryName]].
	messageFile endAppend.! !

!MailDB methodsFor: 'fetch-import-export' stamp: 'jm 10/2/1998 15:51'!
removeMessageCount: msgCount fromPOPConnection: popConnection
	"Remove messages 1 through msgCount from the given POP3 server."

	('Removing ', msgCount printString, ' messages from the server...')
		displayProgressAt: Sensor mousePoint
		from: 0
		to: msgCount
		during: [:progressBar |
			1 to: msgCount do: [:messageNum |
				progressBar value: messageNum.
				popConnection isConnected ifFalse: [
					popConnection destroy.  "network error"
					^ self inform: 'Server connection unexpectedly closed.'].
				popConnection deleteMessage: messageNum]].
! !

!MailDB methodsFor: 'housekeeping'!
appendMessages: msgBuffer messageFile: msgFile indexFile: idxFile
	"Append the given collection of messages to the message file. msgBuffer is a collection of (message ID, message text) pairs."

	| id msgText location entry |
	msgBuffer do:
		[: idAndText |
		 id _ idAndText at: 1.
		 msgText _ idAndText at: 2.
		 location _ msgFile basicAppend: msgText id: id.
		 entry _ indexFile
			at: id
			ifAbsent:
				[IndexFileEntry
					message: (MailMessage from: msgText)
					location: location
					messageFile: msgFile
					msgID: id].
		 entry _ (entry copy) location: location; textLength: msgText size.
		 idxFile at: id put: entry].! !

!MailDB methodsFor: 'housekeeping'!
cleanUpCategories
	"Prune the dead wood out of all categories."

	categoriesFile categories do:
		[: category |
		 categoriesFile removeMessagesInCategory: category butNotIn: indexFile].! !

!MailDB methodsFor: 'housekeeping' stamp: 'sr 2/19/2001 07:48'!
compact
	"Compact the message file and rebuild the index file. Answer an array  
	containing with the number of messages and the number of bytes  
	recovered."
	| newMessageFile newIndexFile stats |
	newMessageFile _ MessageFile openOn: rootFilename , '.messages.tmp'.
	"don't read log file here!!"
	newIndexFile _ IndexFile
				openOn: rootFilename , '.index.tmp'
				messageFile: newMessageFile
				readLogFlag: false.
	stats _ self copyUndeletedTo: newMessageFile indexFile: newIndexFile.
	newMessageFile save.
	newIndexFile save.
	messageFile rename: rootFilename , '.messages.bak'.
	indexFile rename: rootFilename , '.index.bak'.
	newMessageFile rename: rootFilename , '.messages'.
	newIndexFile rename: rootFilename , '.index'.
	indexFile delete.
	messageFile delete.
	messageFile _ MessageFile openOn: rootFilename , '.messages'.
	"update messageFile in IndexFile entries by clean reopen of indexFile"
	indexFile _ IndexFile
				openOn: rootFilename , '.index'
				messageFile: messageFile
				readLogFlag: true.
	self cleanUpCategories.
	categoriesFile save.
	^ stats! !

!MailDB methodsFor: 'housekeeping' stamp: 'mdr 4/9/2001 14:10'!
copyUndeletedTo: newMsgFile indexFile: newIndexFile
	"Copy all the undeleted messages in my current message file into the new message file, recording their locations in the new index file.  Also eliminates duplicate messageIDs.  Answer an array containing with the number of messages and the number of bytes recovered, as well as the number of messages still remaining."

	| bufferLimit msgBuffer bufferSize deletedCount deletedBytes msgIDlist keptCount duplicateMsgCount |

	msgIDlist _ Set new: 10000.	"Record of the msgIDs we have already processed"
	deletedCount _ deletedBytes _ 0.
	keptCount _ 0.
	duplicateMsgCount _ 0.

	"Note: To reduce disk seeks, messages are buffered and written in large batches.  You may wish to tune the amount of buffering if you have a particular shortage or abundance of physical memory.  bufferLimit is the approximate number of bytes of messages that will be accumulated before writing the buffered messages to disk."
	Smalltalk garbageCollect.
	msgBuffer _ OrderedCollection new: 1000.
	bufferLimit _ (Smalltalk primBytesLeft // 2) min: 2000000.
	bufferSize _ 0.

	newMsgFile beginAppend.
	messageFile messagesDo:
		[: deleted : msgID : msgText |
		 (deleted)
			ifTrue:
				[deletedCount _ deletedCount + 1.
				 deletedBytes _ deletedBytes + msgText size]
			ifFalse:
				[
				(msgIDlist includes: msgID) ifTrue: [	"We have a duplicate msgID"
					"We only renumber if we have previously salvaged"
					"and thus know all of the existing message IDs"
					(canRenumberMsgIDs = true)
						ifTrue: [msgID _ self nextUnusedID]
						ifFalse: [duplicateMsgCount _ duplicateMsgCount + 1]
					].
				msgIDlist add: msgID.

				msgBuffer addLast: (Array with: msgID with: msgText).
				keptCount _ keptCount + 1.
				 bufferSize _ bufferSize + msgText size.
				 (bufferSize >= bufferLimit) ifTrue:
					[self
						appendMessages: msgBuffer
						messageFile: newMsgFile
						indexFile: newIndexFile.
					 msgBuffer _ OrderedCollection new: 1000.
					 bufferSize _ 0]]].

	"flush remaining buffered messages"
	self
		appendMessages: msgBuffer
		messageFile: newMsgFile
		indexFile: newIndexFile.
	newMsgFile endAppend.

	(canRenumberMsgIDs = true) ifTrue: [
		canRenumberMsgIDs _ nil.	"We're now done with renumbering duplicate IDs"
		[duplicateMsgCount = 0] assert.
		].

	duplicateMsgCount > 0 ifTrue: [
		canRenumberMsgIDs _ true.		"Allow renumbering duplicate IDs next time around"
		lastIssuedMsgID _ nil.			"Ensure it is later initialized by nextUnusedID"
		self inform:
			'Warning:  ', duplicateMsgCount printString, ' duplicate msgIDs were found.', String cr,
			'Please use "salvage & compact" again to replace them with the correct unique IDs'.
		].

	"return statistics"
	^Array with: deletedCount with: deletedBytes with: keptCount! !

!MailDB methodsFor: 'housekeeping'!
fileDuplicatesIn: categoryName
	"MailDB someInstance fileDuplicatesIn: '.duplicates.'"

	self fileAll: self findDuplicates inCategory: categoryName.
! !

!MailDB methodsFor: 'housekeeping' stamp: 'dvf 6/10/2000 18:33'!
findDuplicates
	"MailDB someInstance findDuplicates"
	| msgsAtTime duplicates msgsBySize similarMessages textCache first second text1 text2 |
	duplicates _ PluggableSet integerSet.
	msgsAtTime _ ((self messagesIn: '.all.')
				collect: [:e | indexFile at: e])
				groupBy: [:e | e time]
				having: [:arr | arr size > 1].
	msgsAtTime
		associationsDo: 
			[:assoc | 
			msgsBySize _ assoc value groupBy: [:e | e textLength]
						having: [:arr | arr size > 1].
			msgsBySize
				associationsDo: 
					[:assoc2 | 
					similarMessages _ assoc2 value.
					textCache _ PluggableDictionary integerDictionary.
					similarMessages combinations: 2
						atATimeDo: 
							[:each | 
							first _ each first.
							second _ each second.
							((first likelyEqual: second)
								and: 
									[text1 _ textCache at: first msgID ifAbsentPut: [(self getMessage: first msgID) bodyText].
									text2 _ textCache at: second msgID ifAbsentPut: [(self getMessage: second msgID) bodyText].
									text1 = text2])
								ifTrue: [duplicates add: second msgID]]]].
	^ duplicates asArray! !

!MailDB methodsFor: 'housekeeping' stamp: 'mdr 4/9/2001 13:05'!
nextUnusedID
	"Answer the next unused message identifier number."

	"Each message needs to have a unique ID.  Message ID's are a monotonically increasing integers roughly related to the time that they were requested.  The last ID used is kept in lastIssuedMsgID, to guard against reuse (e.g. if the clock changes)."

	| id |
	(lastIssuedMsgID isNil) ifTrue: [ 		"find the largest msgID currently in this database"
		lastIssuedMsgID _ 0.
		indexFile keys do: [ :msgID | lastIssuedMsgID _ lastIssuedMsgID max: msgID].
		].

 	"message ID's are roughly the number of seconds since the beginning of 1980"
	id _ Date today asSeconds + Time now asSeconds -
		(Date newDay: 1 year: 1980) asSeconds.
	id _ id max: (lastIssuedMsgID + 1).  "never go backwards!!"
	lastIssuedMsgID _ id.
	^ id

	"MailDB someInstance nextUnusedID"! !

!MailDB methodsFor: 'categories'!
addCategory: categoryName
	"Create a category with the given name if one doesn't already exist."

	categoriesFile addCategory: categoryName.! !

!MailDB methodsFor: 'categories'!
allCategories
	"Answer a list of categories sorted in alphabetical order, including the special categories."

	^categoriesFile categories asSortedCollection asOrderedCollection! !

!MailDB methodsFor: 'categories'!
categoriesThatInclude: msgID
	"Answer a collection of names for real categories that include the message with the given ID. Pseudo-categories (such as '.unclassified.') are not considered real categories."

	^categoriesFile categories select:
		[: catName |
		 (categoriesFile messagesIn: catName) includes: msgID]! !

!MailDB methodsFor: 'categories'!
file: msgID inCategory: categoryName
	"File the message with the given ID in the given category."

	categoriesFile file: msgID inCategory: categoryName.! !

!MailDB methodsFor: 'categories'!
fileAll: msgIDList inCategory: categoryName
	"File all the messages with ID's in the given list in the given category."

	msgIDList do:
		[: msgID |
		 categoriesFile file: msgID inCategory: categoryName].! !

!MailDB methodsFor: 'categories' stamp: 'dvf 6/3/2000 15:06'!
messagesIn: categoryName 
	"Answer a collection of message ID's for the messages in the given 
	category, sorted in ascending time order.  If the category does not exist, 
	answer an empty collection. The pseudo-categories '.all.' and 
	'.unclassified.' are computed dynamically, which may take a little time."
	| msgList category |
	categoryName = '.unclassified.'
		ifTrue: 
			[Cursor execute showWhile: [msgList _ categoriesFile unclassifiedFrom: indexFile keys].
			^ msgList].
	categoryName = '.all.' ifTrue: [^ indexFile keys].
	"otherwise, it is a real category"
	category _ categoriesFile messagesIn: categoryName.
	^self sortedKeysForMessages: category.
	! !

!MailDB methodsFor: 'categories'!
remove: msgID fromCategory: categoryName
	"Remove the message with the given ID from the given category."

	categoriesFile remove: msgID fromCategory: categoryName.! !

!MailDB methodsFor: 'categories'!
removeAll: msgIDList fromCategory: categoryName
	"Remove all the messages with ID's in the given list from the given category."

	msgIDList do:
		[: msgID |
		 categoriesFile remove: msgID fromCategory: categoryName].! !

!MailDB methodsFor: 'categories'!
removeCategory: categoryName
	"Remove the category with the given name. This does nothing if the category does not exist or if it is a pseudo-category."

	categoriesFile removeCategory: categoryName.! !

!MailDB methodsFor: 'categories'!
removeFromAllCategories: msgID
	"Remove the message with the given ID from all categories. The message will appear in 'unclassified'."

	categoriesFile categories do:
		[: categoryName |
		 categoriesFile remove: msgID fromCategory: categoryName].! !

!MailDB methodsFor: 'categories' stamp: 'jm 10/4/1998 11:16'!
renameCategory: oldName to: newName
	"Rename the given category. This does nothing if the category does not exist or if it is a special category ('.all.' or '.unclassified.')."

	categoriesFile renameCategory: oldName to: newName.
! !

!MailDB methodsFor: 'categories' stamp: 'dvf 6/3/2000 17:05'!
sortedKeysForMessages: aSet 
	"use a heuristic to choose method of obtaining sorted message list"
	^ aSet size * (aSet size log: 2) * 3 > indexFile keysCount
		ifTrue: [indexFile keys select: [:msgID | "indexFile keys is sorted"
				aSet includes: msgID]]
		ifFalse: [(aSet asArray
				mergeSortFrom: 1
				to: aSet size
				by: [:a :b | (self getTOCentry: a) time < (self getTOCentry: b) time]) asOrderedCollection]! !

!MailDB methodsFor: 'messages' stamp: 'jm 10/4/1998 11:13'!
addNewMessage: message
	"Add the given message to the database, and answer its message id."

	| id location |
	id _ self nextUnusedID.
	location _ messageFile append: message text id: id.
	indexFile
		at: id
		put: (IndexFileEntry
				message: message
				location: location
				messageFile: messageFile
				msgID: id).
	^ id
! !

!MailDB methodsFor: 'messages'!
deleteAll: msgIDList
	"Delete all the messages with ID's in the given list from the message file. This is permanent!!"

	msgIDList do:
		[: msgID |
		 messageFile
			deleteMessageAt: (indexFile at: msgID) location
			id: msgID.
		 indexFile remove: msgID].
	self cleanUpCategories.! !

!MailDB methodsFor: 'messages'!
getMessage: msgID
	"Answer the MailMessage with the given ID."

	^MailMessage from: (self getText: msgID)! !

!MailDB methodsFor: 'messages'!
getTOCentry: msgID
	"Answer the table-of-contents entry for the message with the given ID."

	^indexFile at: msgID! !

!MailDB methodsFor: 'messages'!
getTOCstring: msgID
	"Answer the table-of-contents string for the message with the given ID."

	^(indexFile at: msgID) tocString! !

!MailDB methodsFor: 'messages' stamp: 'sbw 12/25/2000 20:35'!
getTOCstringAsColumns: msgID 
	^ (indexFile at: msgID) tocStringAsColumns! !

!MailDB methodsFor: 'messages'!
getText: msgID
	"Answer the text for the message with the given ID."

	| entry |
	entry _ indexFile at: msgID.
	^messageFile
		getMessage: msgID
		at: entry location
		textLength: entry textLength! !

!MailDB methodsFor: 'messages'!
newText: newText for: msgID
	"Replace the text for the message with the given ID."

	| oldLocation newLocation newEntry |
	oldLocation _ (indexFile at: msgID) location.
	newLocation _ messageFile update: newText at: oldLocation id: msgID.
	newEntry _ IndexFileEntry
		message: (MailMessage from: newText)
		location: newLocation
		messageFile: messageFile
		msgID: msgID.
	indexFile at: msgID put: newEntry.! !

!MailDB methodsFor: 'printing' stamp: 'dvf 4/29/2000 15:27'!
printOn: aStream 
	aStream nextPutAll: 'a MailDB on '.
	rootFilename ifNotNil: [aStream nextPutAll: '''' , rootFilename , '''']! !

!MailDB methodsFor: 'testing' stamp: 'mdr 4/12/2001 15:14'!
selfTest
	"This is purely for testing purposes.  It checks out various things to make sure that everything is well formed and looks as it should.  This can be a bit slow, but is very useful because it tests much of Celeste using every message in the mail database"

"NOTE: The mechanism used to generate IndexFileEntries has changed significantly over time, especially as MIME support was added and bugs were fixed.  That means that entries generated two years ago can sometimes be different from what would be generated with a current system.  Part of the selfTest compares the actual entry in the index file to what would be generated now.  The differences highlight three things:
	(1) Changes in convention between then and now (e.g. how we handle white space in a header continuation lines)
	(2) Results of bugs that were in the system when the entry was created and are now fixed
	(3) Functional result of changes made to Celeste
(1) and (3) are particularly helpful to use as part of testing enhancements to Celeste."

	| msgIDlist delCount goodCount msg dupid msgTextFromID indexEntry testEntry |

	msgIDlist _ Set new: 10000.
	delCount _ goodCount _ 0.
	dupid _ 0.

	messageFile messagesDo: [ :deleted :msgID :msgBody |

		deleted
			ifTrue: [ delCount _ delCount + 1 ]
			ifFalse: [ goodCount _ goodCount + 1 ].

		(msgIDlist includes: msgID)
			ifTrue: [dupid _ dupid + 1]
			ifFalse: [deleted ifFalse: [msgIDlist add: msgID]].

		"Try creating a formated version of the message from it's raw text"
		msg _ MailMessage from: msgBody.
		msg selfTest.
		
		deleted ifFalse: [
			"Check the indexing information for this message"

			"Check that the contents of this message is the same as what the index provides"
			msgTextFromID _ self getText: msgID.
			[msgTextFromID = msgBody] assert.

			"Check that the index entry is equivalent to what would be produced now"
			indexEntry _ indexFile at: msgID.
			testEntry _ IndexFileEntry message: msg location: indexEntry location messageFile: messageFile msgID: msgID.
			indexEntry selfTestEquals: testEntry. 
		]].

	Transcript cr; show: 'Dup:', dupid asString, '  del:', delCount asString, '  good:', goodCount asString; cr.

	"MailDB someInstance selfTest"! !

!MailDB methodsFor: 'copying' stamp: 'ls 6/21/2001 17:06'!
veryDeepCopyWith: deepCopier
	"don't copy MailDB's -- they refer to external state in files, and the user almost certainly does not intend for a completely independent MailDB to be created"
	^self! !

!MailDB methodsFor: '*sbceleste-operations' stamp: 'nk 12/7/2002 09:31'!
hasFile
	^messageFile notNil and: [ categoriesFile notNil ].! !

!MailDB methodsFor: '*sbceleste-operations' stamp: 'nk 12/7/2002 09:24'!
itemActionFor: aVisitor
	^aVisitor doMailDB: self! !


!MailDB class methodsFor: 'instance creation' stamp: 'ls 6/21/2001 00:05'!
isADBNamed: dbname
	"return whether there is a MailDB on disk with the specified name"
	| status |
	status := self dbStatusFor: dbname.
	^status ~~ #doesNotExist.! !

!MailDB class methodsFor: 'instance creation' stamp: 'tk 6/24/1999 07:22'!
openOn: rootFilename
	"Open or create a mail database with the given root filename. If an instance of me exists with the given root filename, return a reference to that instance rather than creating a new one. This allows multiple MailReaders to be open on the same database without synchronization problems."

	| alreadyOpenDB |
	alreadyOpenDB _ self allSubInstances
		detect:
			[: db |
			 (db rootFilename notNil) and:
			 [db rootFilename = rootFilename]]
		ifNone: [nil].
	(alreadyOpenDB notNil)
		ifTrue: [^alreadyOpenDB]
		ifFalse: [^(self new) openOn: rootFilename].! !

!MailDB class methodsFor: 'utilities'!
readIntegerLineFrom: aStream
	"Read a positive integer from the given stream. Answer zero if there are no digits. Consume the stream through the next carriage return."

	| digit value |
	value _ 0.
	[aStream atEnd] whileFalse: 
		[digit _ aStream next digitValue.
		 ((digit >= 0) & (digit <= 9))
			ifTrue: 
				[value _ (value * 10) + digit]
			ifFalse:
				[(digit == Character cr digitValue) ifFalse:
					[self skipRestOfLine: aStream].
				 ^value]].
	^value! !

!MailDB class methodsFor: 'utilities' stamp: 'ls 9/8/1998 05:19'!
readStringLineFrom: aStream 
	"Read and answer the next line from the given stream. Consume the carriage return but do not append it to the string."

	| |

	^aStream upTo: Character cr! !

!MailDB class methodsFor: 'utilities'!
skipRestOfLine: aStream
	"Consume characters from the given stream through the next carriage return."

	| crValue |
	crValue _ Character cr asciiValue.
	[aStream atEnd or:
	 [aStream next asciiValue == crValue]] whileFalse:
		["consume until end of stream or a carriage return"].! !

!MailDB class methodsFor: 'shut down' stamp: 'tk 6/24/1999 11:35'!
shutDown
	"snapshot all mail databases to disk"

	self allSubInstancesDo: [:db | db saveDB]! !

!MailDB class methodsFor: 'private' stamp: 'ls 6/21/2001 00:04'!
dbStatusFor: rootFilename

	"See if the named databes exists. Since the database has several components, the answer is one of:
	#exists				all files exist, and were created in the right order
	#partialDatabase	only some of the files exist
	#doesNotExist		none of the files exist"

	| dir localName messageFileExists indexFileExists categoriesFileExists messageFileTime categoriesFileTime |

	dir _ FileDirectory forFileName: rootFilename.
	localName _ FileDirectory localNameFor: rootFilename.

	messageFileExists _ dir includesKey: localName, '.messages'.
	indexFileExists _ dir includesKey: localName, '.index'.
	categoriesFileExists _ dir includesKey: localName, '.categories'.

	"Check if no parts of the database exist"
	(messageFileExists | indexFileExists | categoriesFileExists) ifFalse: [^ #doesNotExist].

	"Check if the database was written in a normal sequence"
	(messageFileExists & indexFileExists & categoriesFileExists) ifTrue: [
		messageFileTime _ (dir entryAt: localName, '.messages') modificationTime.
		categoriesFileTime _ (dir entryAt: localName, '.categories') modificationTime.

		"Unfortunately the strongest thing we can say is that the message file should be the oldest file on disk, and the categories file the newest"
		(messageFileTime <= categoriesFileTime)
			ifTrue: [^ #exists].
		].

	^ #partialDatabase
! !


!MailDBFile methodsFor: 'file operations' stamp: 'ls 9/10/1998 01:40'!
delete
	"Delete this file."

	FileDirectory splitName: filename to: [:dirPath :name |
		(FileDirectory forFileName: filename) 
			deleteFileNamed: name ifAbsent: []].
! !

!MailDBFile methodsFor: 'file operations'!
openOn: aFileName
	"Initialize myself from the file with the given name."

	| fileStream |
	filename _ aFileName.
	fileStream _ FileStream fileNamed: aFileName.
	self readFrom: fileStream.
	fileStream setToEnd; close; release.
		"close and release the file stream"
	fileStream _ nil.! !

!MailDBFile methodsFor: 'file operations' stamp: 'ls 9/10/1998 01:35'!
rename: newFileName
	"Rename this file."

	FileDirectory splitName: filename to: [:dirPath :oldFileName |
		(FileDirectory forFileName: filename) 
			rename: oldFileName toBe: newFileName].
	filename _ newFileName.
! !

!MailDBFile methodsFor: 'file operations' stamp: 'mdr 3/20/2001 19:10'!
save
	"Atomically save a representation of this object to its file. The old file is 
	renamed to '<oldname>.bak' before the new file is written. If the write 
	operation fails, the old file may be restored by renaming it. If it 
	succeeds, the .bak file is deleted."
	"create the file if it doesn't already exist"
	| f dir shortName |

	(StandardFileStream fileNamed: filename) close.	"ensure it exists"
	shortName _ FileDirectory localNameFor: filename.
	dir _ FileDirectory forFileName: filename.
	dir rename: shortName toBe: shortName , '.bak'.
	Cursor write showWhile: [
		f _ FileStream fileNamed: filename.
		self writeOn: f.
		f setToEnd; close
		].
	dir deleteFileNamed: shortName , '.bak' ifAbsent: []! !

!MailDBFile methodsFor: 'read-write'!
readFrom: aStream
	"Subclasses must override this method to provide a means of reading themselves into memory."

	self subclassResponsibility! !

!MailDBFile methodsFor: 'read-write'!
writeOn: aStream
	"Subclasses must override this method to provide a means of writing themseves out on their files."

	self subclassResponsibility! !

!MailDBFile methodsFor: 'error reporting'!
reportInconsistency
	"Report that the index file is not consistent with the messages file."

	self inform:
'The .index file is not consistent with the .messages file.
Choosing ''salvage & compact'' will rebuild the index from scratch.'! !


!CategoriesFile methodsFor: 'categories access' stamp: 'dvf 6/10/2000 18:32'!
addCategory: categoryName 
	"Add a new category, if it doesn't already exist."
	(self categories includes: categoryName)
		ifFalse: [categories at: categoryName put: PluggableSet integerSet]! !

!CategoriesFile methodsFor: 'categories access'!
categories
	"Answer a collection of my categories, including the pseudo-categories '.unclassified.' and '.all.'. '.unclassified.' contains the orphaned messages that would otherwise not appear in any category. '.all.' contains all the messages in the database. Since these pseudo-categories are computed on the fly, there may be a noticable delay when one of them is selected."

	^(categories keys)
		add: '.all.';
		add: '.unclassified.';
		yourself! !

!CategoriesFile methodsFor: 'categories access' stamp: 'mdr 3/31/2001 08:31'!
file: messageID inCategory: categoryName 
	"Add the given message ID to the given category. The target category  
	must be a real category, not a pseudo-category."

	(categoryName = '.unclassified.') | (categoryName = '.all.') ifTrue: [^ self].
	self addCategory: categoryName.
	(categories at: categoryName)
		add: messageID! !

!CategoriesFile methodsFor: 'categories access'!
isUnclassified: messageID
	"Answer true if the given message ID does not appear in any of my real (not pseudo) categories."

	categories do:
		[: category | (category includes: messageID) ifTrue: [^false]].
	^true! !

!CategoriesFile methodsFor: 'categories access'!
messagesIn: category
	"Answer a collection of message ID's for the messages in the given category. The pseudo-categories are dynamically computed and so they cannot be accessed in this manner."

	^categories at: category ifAbsent: [#()]! !

!CategoriesFile methodsFor: 'categories access'!
remove: messageID fromCategory: categoryName
	"Remove the given message ID from the given category."

	| msgList |
	msgList _ categories at: categoryName ifAbsent: [^self].
	msgList remove: messageID ifAbsent: [].! !

!CategoriesFile methodsFor: 'categories access'!
removeCategory: categoryName
	"Remove the given category, if it exists."

	categories removeKey: categoryName ifAbsent: [].! !

!CategoriesFile methodsFor: 'categories access'!
removeMessagesInCategory: categoryName butNotIn: indexFile
	"Used to clean the dead wood out of a category."

	| oldMsgs newMsgs |
	oldMsgs _ categories at: categoryName ifAbsent: [^self].
	newMsgs _ oldMsgs copy.
	oldMsgs do:
		[: msgID |
		 (indexFile includesKey: msgID) ifFalse:
			[newMsgs remove: msgID]].
	categories at: categoryName put: newMsgs.! !

!CategoriesFile methodsFor: 'categories access' stamp: 'mdr 3/17/2001 10:47'!
renameCategory: oldName to: newName 
	"Rename the given category."

	| oldEntry |

	"can't rename a special category or overwrite an existing one"
	(oldName = '.all.') | (oldName = '.unclassified.') | (self categories includes: newName)
		ifTrue: [^ self].

	oldEntry _ categories removeKey: oldName ifAbsent: [PluggableSet integerSet].
	categories at: newName put: oldEntry! !

!CategoriesFile methodsFor: 'categories access'!
unclassifiedFrom: messageIDs
	"Answer the subset of the given set of message ID's that do not appear in any category."

	^messageIDs select:
		[: msgID | self isUnclassified: msgID]! !

!CategoriesFile methodsFor: 'read-write' stamp: 'dvf 6/10/2000 18:33'!
readFrom: aFileStream 
	"Read the categories from the given FileStream."
	| name categorySize messageIDs |
	categories _ Dictionary new: 64.
	aFileStream binary; position: 0.
	[aFileStream atEnd]
		whileFalse: 
			[name _ aFileStream ascii; nextString.
			categorySize _ aFileStream binary; nextWord.
			messageIDs _ PluggableSet integerSet.
			categorySize timesRepeat: [messageIDs add: aFileStream nextInt32].
			categories at: name put: messageIDs]! !

!CategoriesFile methodsFor: 'read-write'!
writeOn: aFileStream
	"Write the categories to the given FileStream. The categories data is stored in binary (as opposed to a human-readable form) to save space."

	aFileStream binary; position: 0.
	categories associationsDo:
		[: category |
		 "(category key) is the category name"
		 "(category value) is the set of message ID's in that category"
		 aFileStream nextStringPut: (category key).
		 aFileStream nextWordPut: (category value) size.
		 (category value) do:
			[: messageID |
			 aFileStream nextInt32Put: messageID]].! !


!IndexFile methodsFor: 'file operations' stamp: 'sr 2/19/2001 07:36'!
delete
	| logFilename |
	"delete logfile"
	logFilename _ filename , '.log'.
	FileDirectory
		splitName: logFilename
		to: [:dirPath :name | (FileDirectory forFileName: logFilename)
				deleteFileNamed: name
				ifAbsent: []].
	"Delete this file."
	super delete! !

!IndexFile methodsFor: 'file operations' stamp: 'sr 2/19/2001 06:41'!
openOn: aFileName messageFile: messageFile readLogFlag: readLogFlag
	"Initialize myself from the file with the given name."
	| fileStream |
	filename _ aFileName.
	fileStream _ FileStream fileNamed: aFileName.
	self
		readFrom: (ReadStream on: fileStream contentsOfEntireFile)
		messageFile: messageFile.
	readLogFlag ifTrue: [self readLogMessageFile: messageFile].
	"close and release the file stream"
	fileStream close.
	fileStream _ nil! !

!IndexFile methodsFor: 'file operations' stamp: 'sr 2/19/2001 09:19'!
readLogMessageFile: messageFile 
	| file msgID entry |
	file _ self logStream position: 0.
	[file atEnd]
		whileFalse: [(file peekFor: $r)
				ifTrue: [MailDB readStringLineFrom: file.
					self
						privateRemove: (MailDB readIntegerLineFrom: file)]
				ifFalse: [msgID _ MailDB readIntegerLineFrom: file.
					entry _ IndexFileEntry
								readFrom: file
								messageFile: messageFile
								msgID: msgID.
					self privateAt: msgID put: entry]].
	self logStream close! !

!IndexFile methodsFor: 'file operations' stamp: 'sr 2/19/2001 07:28'!
rename: newFileName 
	"rename log file"
	| logFilename newLogFilename |
	logFilename _ filename , '.log'.
	newLogFilename _ newFileName , '.log'.
	FileDirectory
		splitName: logFilename
		to: [:dirPath :oldFileName | 
			| fd | 
			fd _ FileDirectory forFileName: logFilename.
			(fd fileExists: logFilename)
				ifTrue: [fd rename: oldFileName toBe: newLogFilename]].
	"at last, it changes filename!!"
	super rename: newFileName! !

!IndexFile methodsFor: 'dictionary access'!
at: msgID
	"Answer the IndexFileEntry for the message with the given ID."

	^msgDictionary at: msgID ifAbsent: [self reportInconsistency]! !

!IndexFile methodsFor: 'dictionary access'!
at: msgID ifAbsent: aBlock
	"Answer the IndexFileEntry for the message with the given ID. Evaluate the given block if there is no entry for the given ID."

	^msgDictionary at: msgID ifAbsent: aBlock! !

!IndexFile methodsFor: 'dictionary access' stamp: 'sr 2/19/2001 07:54'!
at: msgID put: anIndexFileEntry 
	"Associate the given IndexFileEntry with the given message ID."
	self privateAt: msgID put: anIndexFileEntry.
	self logStream print: msgID;
	 cr.
	"message ID"
	anIndexFileEntry writeOn: self logStream.
	self logStream close! !

!IndexFile methodsFor: 'dictionary access'!
includesKey: msgID
	"Answer true if my message dictionary contains an entry for the message with the given ID."

	^msgDictionary includesKey: msgID! !

!IndexFile methodsFor: 'dictionary access'!
keys
	"Answer a collection of message IDs for the messages in this IndexFile, sorted in ascending timestamp order. Because sorting is expensive, the sorted key list is cached."

	| keys |
	keys _ OrderedCollection new: timeSortedEntries size * 2.
	timeSortedEntries do: [: assoc | keys addLast: assoc key].
	^keys! !

!IndexFile methodsFor: 'dictionary access' stamp: 'dvf 6/3/2000 16:56'!
keysCount
	^msgDictionary size! !

!IndexFile methodsFor: 'dictionary access' stamp: 'RAA 9/14/2000 16:00'!
logStream

	logfile ifNil: [
		^logfile _ (StandardFileStream fileNamed: filename,'.log') setToEnd
	].
	logfile closed ifTrue: [logfile open; setToEnd].
	^ logfile! !

!IndexFile methodsFor: 'dictionary access' stamp: 'dvf 4/30/2000 00:10'!
privateAt: msgID put: anIndexFileEntry 
	"Associate the given IndexFileEntry with the given message ID."
	timeSortedEntries removeAllSuchThat: [:assoc | assoc key = msgID].
	"don't duplicate the entry!!"
	msgDictionary at: msgID put: anIndexFileEntry.
	timeSortedEntries add: (Association key: msgID value: anIndexFileEntry).
	! !

!IndexFile methodsFor: 'dictionary access' stamp: 'dvf 4/30/2000 00:09'!
privateRemove: msgID 
	"Remove the entry with the given ID from my Dictionary."
	timeSortedEntries removeAllSuchThat: [:assoc | assoc key = msgID].
	msgDictionary removeKey: msgID ifAbsent: [].
	! !

!IndexFile methodsFor: 'dictionary access' stamp: 'dvf 4/30/2000 00:59'!
remove: msgID 
	"Remove the entry with the given ID from my Dictionary."
	self privateRemove: msgID.
	self logStream nextPutAll: 'remove';
	 cr;
	 print: msgID;
	 cr;
	 close! !

!IndexFile methodsFor: 'read-write' stamp: 'dvf 6/11/2000 01:02'!
readFrom: aStream messageFile: messageFile 
	"Initialize myself from the given text stream. It is assumed that the 
	.index file was written in order of ascending message timestamps, 
	although this method is only less efficient, not incorrect, if this is not 
	the case."
	| sorted lastTime msgID entry |
	msgDictionary _ PluggableDictionary integerDictionary.
	timeSortedEntries _ (SortedCollection new: 1000)
				sortBlock: [:m1 :m2 | m1 value time <= m2 value time].
	sorted _ true.
	lastTime _ nil.
	[aStream atEnd]
		whileFalse: 
			[msgID _ MailDB readIntegerLineFrom: aStream.
			entry _ IndexFileEntry
						readFrom: aStream
						messageFile: messageFile
						msgID: msgID.
			msgDictionary at: msgID put: entry.
			timeSortedEntries addLast: (Association key: msgID value: entry).
			(sorted & lastTime notNil and: [lastTime > entry time])
				ifTrue: [sorted _ false].
			lastTime _ entry time].
	sorted ifFalse: [timeSortedEntries reSort]! !

!IndexFile methodsFor: 'read-write' stamp: 'BEO 6/25/2000 15:36'!
save
	| dir shortName |
	super save. 
	self logStream close.
	shortName _ FileDirectory localNameFor: filename.
	dir _ FileDirectory forFileName: filename.
	dir deleteFileNamed: shortName , '.log' ifAbsent: []! !

!IndexFile methodsFor: 'read-write'!
writeOn: aStream
	"Write my index entries to the given text stream in human-readable form."
	"Note: For efficiency, this is done in order of increasing message timestamps, to save the cost of sorting when we read it back in. It is assumed that timeSortedEntries should contains exactly the same message ID's as msgDictionary."

	timeSortedEntries do:
		[: assoc |
		 (assoc key) printOn: aStream.		"message ID"
		 aStream cr.
		 (assoc value) writeOn: aStream].	"index entry"! !


!MailDBFile class methodsFor: 'instance creation'!
openOn: fileName
	"Answer a new instance of me, backed by the file with the given name."

	^(super new) openOn: fileName! !


!IndexFile class methodsFor: 'instance creation' stamp: 'sr 2/19/2001 06:46'!
openOn: fileName messageFile: messageFile readLogFlag: readLogFlag 
	"Answer a new instance of me for the given message file, backed by the 
	file with the given name."
	^ super new
		openOn: fileName
		messageFile: messageFile
		readLogFlag: readLogFlag! !


!MailInboxFile methodsFor: 'read-write'!
readFrom: aStream
	"This operation is a noop for mail inboxes. Use 'messagesDo:' to enumerate the messages in the inbox."! !

!MailInboxFile methodsFor: 'read-write'!
writeOn: aStream
	"This operation is illegal for mail inboxes."

	self error: 'Mail inboxes are read only!!'! !

!MailInboxFile methodsFor: 'scanning'!
delimitersDo: aBlock
	"Invoke the given block for each message in the mail inbox. The block argument is the text of a new message."

	| fileStream stream msgStart msgSize msgText delim |
	fileStream _ FileStream fileNamed: filename.
	Smalltalk garbageCollect.
	(fileStream size < (Smalltalk bytesLeft - 200000))
		ifTrue: [
			"if possible, buffer the entire file in memory for speed"
			stream _ ReadStream on: (fileStream contentsOfEntireFile).
			fileStream _ nil]
		ifFalse: [
			"otherwise, use the actual file stream, reading from disk"
			stream _ fileStream].

	[self scanToNextMessageIn: stream] whileTrue: [
		aBlock value: (MailDB readStringLineFrom: stream)].

	fileStream = nil ifFalse: [fileStream close].! !

!MailInboxFile methodsFor: 'scanning'!
findPossibleMessageStart: aStream
	"Find the next line starting with the string 'From' followed by a space. Leave the input stream positioned at the character following the space."

	(self nextStringIs: 'From ' in: aStream) ifTrue: [^true].
	[true] whileTrue: [
		aStream skipTo: Character cr.
		[aStream peek = Character cr] whileTrue: [aStream next].
		(self nextStringIs: 'From ' in: aStream) ifTrue: [^true].
		aStream atEnd ifTrue: [^false].
	].! !

!MailInboxFile methodsFor: 'scanning' stamp: 'bf 3/9/2000 18:36'!
mailMessagesDo: aBlock
	"Invoke the given block for each message in the mail inbox. The block argument is the text of a new message."

	| fileStream stream msgStart msgSize msgText |
	fileStream _ CrLfFileStream readOnlyFileNamed: filename.
	Smalltalk garbageCollect.
	(fileStream size < (Smalltalk bytesLeft - 200000))
		ifTrue: [
			"if possible, buffer the entire file in memory for speed"
			stream _ ReadStream on: (fileStream contentsOfEntireFile).
			fileStream _ nil]
		ifFalse: [
			"otherwise, use the actual file stream, reading from disk"
			stream _ fileStream].

	self scanToNextMessageIn: stream.
	MailDB skipRestOfLine: stream.  "skip message delimiter"
	msgStart _ stream position.
	[self scanToNextMessageIn: stream] whileTrue: [
		msgSize _ stream position - msgStart.
		stream position: msgStart.
		msgText _ stream next: msgSize.
		MailDB skipRestOfLine: stream.  "skip message delimiter"
		msgStart _ stream position.
		aBlock value: msgText].

	"process final message"
	msgSize _ stream position - msgStart.
	msgSize > 0 ifTrue: [
		stream position: msgStart.
		msgText _ stream next: msgSize.
		aBlock value: msgText].

	fileStream = nil ifFalse: [fileStream close].! !

!MailInboxFile methodsFor: 'scanning'!
nextStringIs: aString in: aStream
	"If the next characters of the given stream form the given string, then advance the stream position by the size of the string and return true. Otherwise, leave the stream untouched and return false."

	| oldPosition |
	oldPosition _ aStream position.
	1 to: aString size do: [ :i |
		aStream next = (aString at: i) ifFalse: [
			aStream position: oldPosition.
			^false
		].
	].
	aStream position: oldPosition.
	^true! !

!MailInboxFile methodsFor: 'scanning' stamp: 'di 4/30/2001 16:25'!
scanToNextMessageIn: aStream
	"Scan to the start of the next message in the given stream. Answer true if we find a message delimiter, false if we hit the end of the stream first. The stream is left positioned at the start of the next message or at the end of the stream."

	| msgStart line dayOfWeek year |
	[aStream atEnd] whileFalse: [
		(self findPossibleMessageStart: aStream) ifFalse: [^false].
		msgStart _ aStream position.
		aStream next: 5.  "skip 'From '"

		"skip address"
		[aStream peek isSeparator] whileFalse: [aStream next].
		[aStream peek = Character space] whileTrue: [aStream next].

		line _ MailDB readStringLineFrom: aStream.
		line size >= 7 ifTrue: [
			dayOfWeek _ (line copyFrom: 1 to: 3) asLowercase.
			year _ (line at: line size - 3) isDigit
					ifTrue: [(line copyFrom: line size - 3 to: line size) asNumber]
					ifFalse: [0].
			((#('sun' 'mon' 'tue' 'wed' 'thu' 'fri' 'sat') includes: dayOfWeek) and:
			[(year > 1900) and: [year < 2100]]) ifTrue: [
				aStream position: msgStart.
				^true  "found a message!!"
			].
		].
	].
	^false! !


!MHMailInboxFile methodsFor: 'scanning'!
mailMessagesDo: aBlock
	"Invoke the given block for each message in the mail inbox. The block argument is the text of a new message."

	| fileStream stream textStart textSize msgText |
	fileStream _ FileStream fileNamed: filename.
	Smalltalk garbageCollect.
	(fileStream size < (Smalltalk bytesLeft - 200000))
		ifTrue:
			["if possible, buffer the entire file in memory for speed"
			 stream _ ReadStream on: (fileStream contentsOfEntireFile).
			 fileStream _ nil]
		ifFalse:
			["otherwise, use the actual file stream, reading from disk"
			 stream _ fileStream].
	[self scanToNextMessageIn: stream] whileTrue:
		["skip the three-line message delimiter"
		 3 timesRepeat: [MailDB skipRestOfLine: stream].
		 textStart _ stream position.
		 self scanToNextMessageIn: stream.
		 textSize _ stream position - textStart.
		 stream position: textStart.
		 msgText _ stream next: textSize.
		 aBlock value: msgText].
	fileStream = nil ifFalse: [fileStream close].! !

!MHMailInboxFile methodsFor: 'scanning'!
scanToNextMessageIn: aStream
	"Scan to the start of the next message in the given stream. Answer true if we find a message delimiter, false if we hit the end of the stream first. The stream is left positioned at the start of the next message delimiter (if there is one) or at the end of the stream."

	| msgStart |
	[true] whileTrue:
		[(aStream skipTo: $:) ifFalse: [^false].	"end of stream"
		 msgStart _ aStream position - 1.
		 ((MailDB readStringLineFrom: aStream) = ':::::::::::::') ifTrue:
			["looking good..."
			 MailDB skipRestOfLine: aStream.	"skip message number"
			 ((MailDB readStringLineFrom: aStream) = '::::::::::::::') ifTrue:
				["found a message!!"
				 aStream position: msgStart. ^true]].
		 "false alarm, keep scanning"
		 aStream position: msgStart + 1].! !


!MailNotifier methodsFor: 'accessing' stamp: 'dvf 4/29/2000 21:50'!
messageCount
	"if no socket, try to connect in background, when done, remove socket."
	socket
		ifNil: 
			[socket _ POPSocket new.
			
			[socket serverName: Celeste popServer.
			socket userName: Celeste popUserName.
			socket password: self password.
			"socket addProgressObserver: Transcript."
			([socket connectToPOP]
				on: Error do: 
				[Transcript show: 'Couldn''t connect to POP.';
				 cr. (Delay forSeconds: 180) wait.
				false])
				ifTrue: 
					[messageCount _ socket numMessages.
					socket disconnectFromPOP.
					lastConnectTime _ Time now].
			socket _ nil]
				forkAt: Processor userBackgroundPriority].
	^ messageCount! !


!MessageFile methodsFor: 'file operations' stamp: 'jm 9/21/1998 16:26'!
close
	"Close the file."

	file ifNil: [^ self].
	file
		ensureOpen;
		setToEnd;
		close.
	file _ nil.
! !

!MessageFile methodsFor: 'file operations'!
delete
	"I must close my file handle before the file can be deleted."

	self close.
	super delete.! !

!MessageFile methodsFor: 'file operations' stamp: 'jm 9/21/1998 16:30'!
ensureFileIsOpen
	"Make sure that my file is open. The file is automatically closed on snapshots."

	file
		ifNil: [file _ FileStream fileNamed: filename]
		ifNotNil: [file ensureOpen].
! !

!MessageFile methodsFor: 'file operations'!
openOn: aFileName
	"Initialize myself for the message file with the given name."

	filename _ aFileName.
	file _ nil.
	self ensureFileIsOpen.! !

!MessageFile methodsFor: 'file operations'!
rename: newFileName
	"I must close my file handle before the file can be renamed."

	self close.
	super rename: newFileName.! !

!MessageFile methodsFor: 'file operations' stamp: 'di 9/29/1998 16:01'!
save
	"Make sure the message file is flushed to disk. This is NOT atomic because MessageFiles can get large and there might not be enough disk space to save them atomically. Besides, it would be very slow."

	file ifNil: [^ self].
	file ensureOpen.
	file closed  "Will still be closed if no file present"
		ifFalse: [file setToEnd; close; reopen].
! !

!MessageFile methodsFor: 'message operations'!
append: messageText id: messageID
	"Append the given message text with the given unique identifier. Answer the new location of the message."

	| location |
	self beginAppend.
	location _ self basicAppend: messageText id: messageID.
	self endAppend.
	^location! !

!MessageFile methodsFor: 'message operations' stamp: 'mdr 12/24/2000 18:32'!
assertValidMessageAt: filePosition id: msgID
	"Verify that the given filePosition is, indeed, the start of a valid undeleted message with the given ID and raise an error if this assertion is false."

	| delimiter fileMsgID |
	"assume file is open"

	file position: filePosition.

	delimiter _ file next: 11.
	(delimiter = ('&&&&&start', String cr)) ifFalse:
		[^self reportInconsistency].

	fileMsgID _ MailDB readIntegerLineFrom: file.
	(msgID = fileMsgID) ifFalse:
		[^self reportInconsistency].

	^true.! !

!MessageFile methodsFor: 'message operations'!
basicAppend: messageText id: messageID
	"Append the given message text with the given message ID. Answer the new location of the message."
	"WARNING: This operation assumes:
		1. the sender positioned the stream to the end of the file (using beginAppend), and
		2. the sender will do an endAppend operation after all messages are appended to flush all file buffers to disk."

	| location |
	file setToEnd.
	location _ file position.
	file nextPutAll: '&&&&&start'.	"message delimiter"
	file cr.
	messageID printOn: file.		"message ID"
	file cr.
	file nextPutAll: messageText.
	^location! !

!MessageFile methodsFor: 'message operations'!
beginAppend
	"Set the file to the end prior to performing a sequence of basicAppend operations."

	self ensureFileIsOpen.
	file setToEnd.! !

!MessageFile methodsFor: 'message operations' stamp: 'mdr 12/24/2000 01:14'!
deleteMessageAt: filePosition id: msgID
	"Mark as deleted the message with the given ID located at the given file position."

	self ensureFileIsOpen.
	(self assertValidMessageAt: filePosition id: msgID)
		ifFalse: [^false].		"Don't delete if it looks like we have a problem"

	file position: filePosition.
	file nextPutAll: '&&&&&XXXXX'.		"delimiter for deleted messages"
	file flush.! !

!MessageFile methodsFor: 'message operations'!
endAppend
	"Complete an append transaction by flushing the file to disk."

	self save.! !

!MessageFile methodsFor: 'message operations'!
getMessage: msgID at: start textLength: textSize
	"Retrieve the message with the given ID, location, and text size."

	self ensureFileIsOpen.
	self assertValidMessageAt: start id: msgID.
	^file next: textSize! !

!MessageFile methodsFor: 'message operations' stamp: 'mdr 3/23/2001 17:25'!
scanToNextAndSigns: aStream
	"Scan the stream for 5 consecutive and-sign (&) characters.  If they are found, position the stream at the start of the and-signs and answer true.  Answer false if the end of the stream is reached"

	| chunk index blocksize target |

	target _ '&&&&&'.
	blocksize _ 4000.		"Must be more than target size :-)"

	"Quickly skip over sections that do not have and-signs."
	index _ 0.
	[index = 0]
		whileTrue:
			[chunk _ aStream next: blocksize.
			chunk size = 0 ifTrue: [^false].		"end of file"
			index _ chunk findString: target.

			"Handle the yucky case where the target might be split between
			this block and the next.  We back up a bit before continuing.
			We back up 4, since the whole target is clearly not there"
			(index = 0 and: [chunk size = blocksize]) ifTrue: [aStream skip: -4]. 
			].

	"We found some &s, so position the stream to read it"
	aStream skip: (chunk size - index + 1) negated.
	[aStream peek = $&] assert.
	^true
! !

!MessageFile methodsFor: 'message operations'!
update: messageText at: oldMessagePosition id: msgID
	"Atomically update the message having the old location and ID with the given new text (e.g. when the user has edited a message). Answer the new location of the message."

	| newLocation |
	newLocation _ self append: messageText id: msgID.
	self deleteMessageAt: oldMessagePosition id: msgID.
	^newLocation! !

!MessageFile methodsFor: 'scanning'!
messagesDo: aBlock
	"Scan the message file and invoke the given block for each message in it. The block arguments are:
	deleted			true if this message is marked deleted
	msgID			the message ID
	msgBody			the message text
This operation is very expensive."

	| more deleted msgID textStart textSize msgBody |
	self ensureFileIsOpen.
	file position: 0.
	more _ self scanToNextMessageIn: file.
	[more] whileTrue:
		[deleted _								"deleted"
			(MailDB readStringLineFrom: file) = '&&&&&XXXXX'.
		 msgID _ MailDB readIntegerLineFrom: file.	"msgID"
		 textStart _ file position.
		 more _ self scanToNextMessageIn: file.
		 textSize _ file position - textStart.
		 file position: textStart.
		 msgBody _ file next: textSize.				"msgBody"
		 aBlock valueWithArguments:
			(Array
				with: deleted
				with: msgID
				with: msgBody)].! !

!MessageFile methodsFor: 'scanning' stamp: 'mdr 3/16/2001 19:50'!
scanToNextMessageIn: aStream
	"Scan to the start of the next message. Answer true if we find a message delimiter, false if we hit the end of the file first. The stream is left positioned at the start of the next message (at the message delimiter) or at the end of the stream."

	| delimiter |
	[self scanToNextAndSigns: aStream] whileTrue:
		[delimiter _ aStream next: 10.
		 ((delimiter = '&&&&&start') or: [delimiter = '&&&&&XXXXX'])
			ifTrue: [aStream skip: -10. ^true]
			ifFalse: [aStream skip: -5]  "Keep going - it was't a delimiter"
		].
	^false	"end of file"! !


!ReadNewsInboxFile methodsFor: 'read-write'!
readFrom: aStream
	"This operation is a noop for news inboxes. Use 'messagesDo:' to enumerate the messages in the inbox."! !

!ReadNewsInboxFile methodsFor: 'read-write'!
writeOn: aStream
	"This operation is illegal for news inboxes."

	self error: 'News inboxes are read only!!'! !

!ReadNewsInboxFile methodsFor: 'scanning'!
allDashes: aString
	"Answer true if the given string is not empty and consists entirely of dash characters."

	(aString isEmpty) ifTrue: [^false].
	aString detect: [: ch | ch ~= $-] ifNone: [^true].
	^false	"we must have detected a non-dash"! !

!ReadNewsInboxFile methodsFor: 'scanning'!
appendLine: aString
	"Append the given line to the buffer."

	msgBuffer nextPutAll: aString; cr.! !

!ReadNewsInboxFile methodsFor: 'scanning'!
endOfArticleDo: aBlock
	"We've just hit the end of an article. Evaluate the given block on the article we've been accumulating in the buffer (if any) and reset the buffer for the next article."

	| msgText end |
	"get text and remove trailing separators (blanks, cr's, etc)"
	msgText _ msgBuffer contents.
	end _ msgText size.
	[(end > 0) and: [(msgText at: end) isSeparator]] whileTrue: [end _ end - 1].
	(end > 1) ifTrue:
		[aBlock value: currentNewsgroup value: (msgText copyFrom: 1 to: end)].
	msgBuffer reset.	"reset the buffer for the next message"! !

!ReadNewsInboxFile methodsFor: 'scanning'!
newsMessagesDo: aBlock
	"Invoke the given block for each message in the news inbox file. The block arguments are the newsgroup name and the text of a new message."

	| fileStream stream |
	fileStream _ FileStream fileNamed: filename.
	(fileStream size < 50000)
		ifTrue:
			["for small inboxes, buffer the entire file in memory for speed"
			 stream _ ReadStream on: (fileStream contentsOfEntireFile)]
		ifFalse:
			["otherwise, use the actual file stream, reading from disk"
			 stream _ fileStream].
	self parse: stream do: aBlock.
	fileStream close.! !

!ReadNewsInboxFile methodsFor: 'scanning'!
parse: aStream do: aBlock
	"Parse the given stream into newsgroup articles, invoking the given block once for each article in the stream. The stream is divided into articles by two kinds of delimiters. The first kind indicates the start of a new newsgroup and includes the newsgroup name. The second kind indicates the start of a new article within a newsgroup."

	| done line nextLine |
	currentNewsgroup _ 'unknown newsgroup'.
	msgBuffer _ WriteStream on: (String new: 5000).
	done _ false.
	[done] whileFalse:
		[(aStream atEnd) ifTrue:
			["end of stream"
			 self endOfArticleDo: aBlock.
			 done _ true].
		 line _ MailDB readStringLineFrom: aStream.
		 (self allDashes: line) ifTrue:	"leading line of dashes"
			["could be a newsgroup header"
			 nextLine _ MailDB readStringLineFrom: aStream.
			 ((nextLine size >= 10) and:
			  [(nextLine copyFrom: 1 to: 10) = 'Newsgroup '])
				ifTrue:
					["yep, it is a newsgroup header"
					 self endOfArticleDo: aBlock.
					 self setNewsGroup: nextLine.
					 MailDB skipRestOfLine: aStream.	"skip trailing line of dashes"
					 MailDB skipRestOfLine: aStream.	"skip blank line"
					 MailDB skipRestOfLine: aStream.	"skip next article delimiter"
					 line _ MailDB readStringLineFrom: aStream]
				ifFalse:
					["nope, it's not a newsgroup header"
					 self appendLine: line.
					 line _ nextLine]].
		 (self startOfArticle: line) ifTrue:
			[self endOfArticleDo: aBlock.
			 line _ MailDB readStringLineFrom: aStream].
		 self appendLine: line].	"normal line: append it to the message buffer"! !

!ReadNewsInboxFile methodsFor: 'scanning'!
setNewsGroup: aLine
	"Set the current newsgroup name from the given line of text, which is of the form:
		Newsgroup comp.lang.smalltalk"

	(aLine size > 11)
		ifTrue: [currentNewsgroup _ aLine copyFrom: 11 to: aLine size]
		ifFalse: [currentNewsgroup _ 'unknown newsgroup'].! !

!ReadNewsInboxFile methodsFor: 'scanning'!
startOfArticle: aString
	"Answer true if the given string is the start of a new news article. That is, does it start with the string 'Article ' and end with a period?"

	^((aString size >= 8) and:
	   [((aString copyFrom: 1 to: 8) = 'Article ') & (aString last = $.)])! !


!RNInboxFile methodsFor: 'scanning'!
nextStringOf: aStream equals: aString

	aString do:
		[: c | (c == (aStream next) ) ifFalse: [^false]].
	^true! !

!RNInboxFile methodsFor: 'scanning'!
parse: aStream do: aBlock
	"Parse the given stream into newsgroup articles, invoking the given block once for each article in the stream. The stream is divided into articles by delimiters that includes the newsgroup name. Ignore text before the first article delimiter."

	| done line groupName |
	currentNewsgroup _ nil.  "have not found start of article"
	msgBuffer _ WriteStream on: (String new: 5000).
	done _ false.
	[done] whileFalse:
		[(aStream atEnd) ifTrue:
			["end of stream"
			 self endOfArticleDo: aBlock.
			 done _ true].
		 line _ MailDB readStringLineFrom: aStream.
		 groupName _ self startOfArticle: line.
		 (groupName notNil) ifTrue:
			[self endOfArticleDo: aBlock.
			 currentNewsgroup _ groupName.
			 line _ MailDB readStringLineFrom: aStream].
		 (currentNewsgroup notNil) ifTrue: [self appendLine: line]].! !

!RNInboxFile methodsFor: 'scanning' stamp: 'bf 3/16/2000 19:19'!
startOfArticle: aString
	"Answer the newsgroup name if the given string is the start of a news article, for example:
		Article 2958 of comp.lang.smalltalk:
	Otherwise, answer nil."

	| s name |
	s _ ReadStream on: aString.
	(self nextStringOf: s equals: 'Article ') ifFalse: [^nil].
	[s next isDigit] whileTrue.	"consumes digits plus the following space"
	(self nextStringOf: s equals: 'of ') ifFalse: [^nil].
	name _ s upTo: $:.
	((name size > 1) & (s atEnd)) ifFalse: [^nil].
	^name! !

CelesteComposition initialize!
Celeste initialize!
"Postscript:
Registers Celeste with the World menu's 'open' sub-menu.  There should be a similar registration process with the ObjectsTool PartsBin and with the Tool flap.  Since there isn't currently, as part of the changeset we have already reverted Flaps class>>quadsDefiningToolsFlap to the previous version ( which contains a quad for Celeste ). "
Celeste registerInOpenMenu.

Utilities informUser: 'Regenerating Celeste thumbnails in Tools flap and PartsBin, please wait...' during: [
PartsBin clearThumbnailCache.
PartsBin cacheAllThumbnails.
Flaps replaceToolsFlap. ].!

